-- qsys.vhd

-- Generated using ACDS version 18.1 625

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

entity qsys is
	port (
		clk_clk       : in    std_logic                    := '0';             --   clk.clk
		led_export    : out   std_logic;                                       --   led.export
		pio_export    : inout std_logic_vector(7 downto 0) := (others => '0'); --   pio.export
		reset_reset_n : in    std_logic                    := '0';             -- reset.reset_n
		uart_rxd      : in    std_logic                    := '0';             --  uart.rxd
		uart_txd      : out   std_logic                                        --      .txd
	);
end entity qsys;

architecture rtl of qsys is
	component qsys_onchip_memory2_0 is
		port (
			clk         : in  std_logic                     := 'X';             -- clk
			address     : in  std_logic_vector(12 downto 0) := (others => 'X'); -- address
			clken       : in  std_logic                     := 'X';             -- clken
			chipselect  : in  std_logic                     := 'X';             -- chipselect
			write       : in  std_logic                     := 'X';             -- write
			readdata    : out std_logic_vector(31 downto 0);                    -- readdata
			writedata   : in  std_logic_vector(31 downto 0) := (others => 'X'); -- writedata
			byteenable  : in  std_logic_vector(3 downto 0)  := (others => 'X'); -- byteenable
			reset       : in  std_logic                     := 'X';             -- reset
			reset_req   : in  std_logic                     := 'X';             -- reset_req
			address2    : in  std_logic_vector(12 downto 0) := (others => 'X'); -- address
			chipselect2 : in  std_logic                     := 'X';             -- chipselect
			clken2      : in  std_logic                     := 'X';             -- clken
			write2      : in  std_logic                     := 'X';             -- write
			readdata2   : out std_logic_vector(31 downto 0);                    -- readdata
			writedata2  : in  std_logic_vector(31 downto 0) := (others => 'X'); -- writedata
			byteenable2 : in  std_logic_vector(3 downto 0)  := (others => 'X'); -- byteenable
			clk2        : in  std_logic                     := 'X';             -- clk
			reset2      : in  std_logic                     := 'X';             -- reset
			reset_req2  : in  std_logic                     := 'X';             -- reset_req
			freeze      : in  std_logic                     := 'X'              -- freeze
		);
	end component qsys_onchip_memory2_0;

	component orca_timer is
		generic (
			TIMER_WIDTH : integer := 64
		);
		port (
			clk             : in  std_logic                     := 'X';             -- clk
			reset           : in  std_logic                     := 'X';             -- reset
			timer_value     : out std_logic_vector(63 downto 0);                    -- value
			timer_interrupt : out std_logic;                                        -- interrupt
			slave_AWLOCK    : in  std_logic_vector(1 downto 0)  := (others => 'X'); -- slave_awlock
			slave_ARCACHE   : in  std_logic_vector(3 downto 0)  := (others => 'X'); -- slave_arcache
			slave_ARID      : in  std_logic_vector(3 downto 0)  := (others => 'X'); -- slave_arid
			slave_ARLEN     : in  std_logic_vector(3 downto 0)  := (others => 'X'); -- slave_arlen
			slave_ARLOCK    : in  std_logic_vector(1 downto 0)  := (others => 'X'); -- slave_arlock
			slave_ARSIZE    : in  std_logic_vector(2 downto 0)  := (others => 'X'); -- slave_arsize
			slave_ARBURST   : in  std_logic_vector(1 downto 0)  := (others => 'X'); -- slave_awburst
			slave_AWBURST   : in  std_logic_vector(1 downto 0)  := (others => 'X'); -- slave_awburst
			slave_AWCACHE   : in  std_logic_vector(3 downto 0)  := (others => 'X'); -- slave_awcache
			slave_AWID      : in  std_logic_vector(3 downto 0)  := (others => 'X'); -- slave_awid
			slave_AWLEN     : in  std_logic_vector(3 downto 0)  := (others => 'X'); -- slave_awlen
			slave_AWSIZE    : in  std_logic_vector(2 downto 0)  := (others => 'X'); -- slave_awsize
			slave_BID       : out std_logic_vector(3 downto 0);                     -- slave_bid
			slave_RID       : out std_logic_vector(3 downto 0);                     -- slave_rid
			slave_RLAST     : out std_logic;                                        -- slave_rlast
			slave_WID       : in  std_logic_vector(3 downto 0)  := (others => 'X'); -- slave_wid
			slave_WLAST     : in  std_logic                     := 'X';             -- slave_wlast
			slave_ARADDR    : in  std_logic_vector(3 downto 0)  := (others => 'X'); -- araddr
			slave_ARPROT    : in  std_logic_vector(2 downto 0)  := (others => 'X'); -- arprot
			slave_ARVALID   : in  std_logic                     := 'X';             -- arvalid
			slave_ARREADY   : out std_logic;                                        -- arready
			slave_RDATA     : out std_logic_vector(31 downto 0);                    -- rdata
			slave_RVALID    : out std_logic;                                        -- rvalid
			slave_RREADY    : in  std_logic                     := 'X';             -- rready
			slave_AWADDR    : in  std_logic_vector(3 downto 0)  := (others => 'X'); -- awaddr
			slave_AWPROT    : in  std_logic_vector(2 downto 0)  := (others => 'X'); -- awprot
			slave_AWVALID   : in  std_logic                     := 'X';             -- awvalid
			slave_AWREADY   : out std_logic;                                        -- awready
			slave_WDATA     : in  std_logic_vector(31 downto 0) := (others => 'X'); -- wdata
			slave_WSTRB     : in  std_logic_vector(3 downto 0)  := (others => 'X'); -- wstrb
			slave_WVALID    : in  std_logic                     := 'X';             -- wvalid
			slave_WREADY    : out std_logic;                                        -- wready
			slave_BVALID    : out std_logic;                                        -- bvalid
			slave_BREADY    : in  std_logic                     := 'X';             -- bready
			slave_BRESP     : out std_logic_vector(1 downto 0);                     -- bresp
			slave_RRESP     : out std_logic_vector(1 downto 0)                      -- rresp
		);
	end component orca_timer;

	component qsys_pio_0 is
		port (
			clk        : in    std_logic                     := 'X';             -- clk
			reset_n    : in    std_logic                     := 'X';             -- reset_n
			address    : in    std_logic_vector(2 downto 0)  := (others => 'X'); -- address
			write_n    : in    std_logic                     := 'X';             -- write_n
			writedata  : in    std_logic_vector(31 downto 0) := (others => 'X'); -- writedata
			chipselect : in    std_logic                     := 'X';             -- chipselect
			readdata   : out   std_logic_vector(31 downto 0);                    -- readdata
			bidir_port : inout std_logic_vector(7 downto 0)  := (others => 'X')  -- export
		);
	end component qsys_pio_0;

	component qsys_pio_1 is
		port (
			clk        : in  std_logic                     := 'X';             -- clk
			reset_n    : in  std_logic                     := 'X';             -- reset_n
			address    : in  std_logic_vector(1 downto 0)  := (others => 'X'); -- address
			write_n    : in  std_logic                     := 'X';             -- write_n
			writedata  : in  std_logic_vector(31 downto 0) := (others => 'X'); -- writedata
			chipselect : in  std_logic                     := 'X';             -- chipselect
			readdata   : out std_logic_vector(31 downto 0);                    -- readdata
			out_port   : out std_logic                                         -- export
		);
	end component qsys_pio_1;

	component qsys_timer_0 is
		port (
			clk        : in  std_logic                     := 'X';             -- clk
			reset_n    : in  std_logic                     := 'X';             -- reset_n
			address    : in  std_logic_vector(2 downto 0)  := (others => 'X'); -- address
			writedata  : in  std_logic_vector(15 downto 0) := (others => 'X'); -- writedata
			readdata   : out std_logic_vector(15 downto 0);                    -- readdata
			chipselect : in  std_logic                     := 'X';             -- chipselect
			write_n    : in  std_logic                     := 'X';             -- write_n
			irq        : out std_logic                                         -- irq
		);
	end component qsys_timer_0;

	component qsys_timer_1 is
		port (
			clk        : in  std_logic                     := 'X';             -- clk
			reset_n    : in  std_logic                     := 'X';             -- reset_n
			address    : in  std_logic_vector(2 downto 0)  := (others => 'X'); -- address
			writedata  : in  std_logic_vector(15 downto 0) := (others => 'X'); -- writedata
			readdata   : out std_logic_vector(15 downto 0);                    -- readdata
			chipselect : in  std_logic                     := 'X';             -- chipselect
			write_n    : in  std_logic                     := 'X';             -- write_n
			irq        : out std_logic                                         -- irq
		);
	end component qsys_timer_1;

	component qsys_uart_0 is
		port (
			clk           : in  std_logic                     := 'X';             -- clk
			reset_n       : in  std_logic                     := 'X';             -- reset_n
			address       : in  std_logic_vector(2 downto 0)  := (others => 'X'); -- address
			begintransfer : in  std_logic                     := 'X';             -- begintransfer
			chipselect    : in  std_logic                     := 'X';             -- chipselect
			read_n        : in  std_logic                     := 'X';             -- read_n
			write_n       : in  std_logic                     := 'X';             -- write_n
			writedata     : in  std_logic_vector(15 downto 0) := (others => 'X'); -- writedata
			readdata      : out std_logic_vector(15 downto 0);                    -- readdata
			rxd           : in  std_logic                     := 'X';             -- export
			txd           : out std_logic;                                        -- export
			irq           : out std_logic                                         -- irq
		);
	end component qsys_uart_0;

	component ORCA is
		generic (
			REGISTER_SIZE                : integer                       := 32;
			RESET_VECTOR                 : std_logic_vector(31 downto 0) := "00000000000000000000000000000000";
			ENABLE_EXCEPTIONS            : natural                       := 1;
			INTERRUPT_VECTOR             : std_logic_vector(31 downto 0) := "00000000000000000000001000000000";
			ENABLE_EXT_INTERRUPTS        : natural                       := 1;
			NUM_EXT_INTERRUPTS           : positive                      := 1;
			MAX_IFETCHES_IN_FLIGHT       : natural                       := 1;
			BTB_ENTRIES                  : natural                       := 16;
			MULTIPLY_ENABLE              : natural                       := 1;
			SHIFTER_MAX_CYCLES           : natural                       := 32;
			DIVIDE_ENABLE                : natural                       := 1;
			PIPELINE_STAGES              : natural                       := 4;
			VCP_ENABLE                   : natural                       := 0;
			POWER_OPTIMIZED              : natural                       := 0;
			FAMILY                       : string                        := "INTEL";
			INSTRUCTION_REQUEST_REGISTER : natural                       := 1;
			INSTRUCTION_RETURN_REGISTER  : natural                       := 0;
			DATA_REQUEST_REGISTER        : natural                       := 1;
			DATA_RETURN_REGISTER         : natural                       := 0;
			LOG2_BURSTLENGTH             : positive                      := 4;
			AXI_ID_WIDTH                 : positive                      := 2;
			AVALON_AUX                   : natural                       := 1;
			LMB_AUX                      : natural                       := 0;
			WISHBONE_AUX                 : natural                       := 0;
			ICACHE_SIZE                  : natural                       := 0;
			ICACHE_LINE_SIZE             : natural                       := 32;
			ICACHE_EXTERNAL_WIDTH        : integer                       := 32;
			IC_REQUEST_REGISTER          : natural                       := 1;
			IC_RETURN_REGISTER           : natural                       := 0;
			DCACHE_SIZE                  : natural                       := 0;
			DCACHE_WRITEBACK             : natural                       := 1;
			DCACHE_LINE_SIZE             : natural                       := 32;
			DCACHE_EXTERNAL_WIDTH        : integer                       := 32;
			DC_REQUEST_REGISTER          : natural                       := 1;
			DC_RETURN_REGISTER           : natural                       := 0;
			UC_MEMORY_REGIONS            : natural                       := 0;
			UMR0_ADDR_BASE               : std_logic_vector(31 downto 0) := "00000000000000000000000000000000";
			UMR0_ADDR_LAST               : std_logic_vector(31 downto 0) := "11111111111111111111111111111111";
			IUC_REQUEST_REGISTER         : natural                       := 0;
			IUC_RETURN_REGISTER          : natural                       := 0;
			DUC_REQUEST_REGISTER         : natural                       := 0;
			DUC_RETURN_REGISTER          : natural                       := 0;
			AUX_MEMORY_REGIONS           : natural                       := 1;
			AMR0_ADDR_BASE               : std_logic_vector(31 downto 0) := "00000000000000000000000000000000";
			AMR0_ADDR_LAST               : std_logic_vector(31 downto 0) := "11111111111111111111111111111111";
			IAUX_REQUEST_REGISTER        : natural                       := 2;
			IAUX_RETURN_REGISTER         : natural                       := 0;
			DAUX_REQUEST_REGISTER        : natural                       := 2;
			DAUX_RETURN_REGISTER         : natural                       := 0
		);
		port (
			clk                           : in  std_logic                     := 'X';             -- clk
			reset                         : in  std_logic                     := 'X';             -- reset
			avm_data_address              : out std_logic_vector(31 downto 0);                    -- address
			avm_data_byteenable           : out std_logic_vector(3 downto 0);                     -- byteenable
			avm_data_read                 : out std_logic;                                        -- read
			avm_data_readdata             : in  std_logic_vector(31 downto 0) := (others => 'X'); -- readdata
			avm_data_write                : out std_logic;                                        -- write
			avm_data_writedata            : out std_logic_vector(31 downto 0);                    -- writedata
			avm_data_waitrequest          : in  std_logic                     := 'X';             -- waitrequest
			avm_data_readdatavalid        : in  std_logic                     := 'X';             -- readdatavalid
			avm_instruction_address       : out std_logic_vector(31 downto 0);                    -- address
			avm_instruction_read          : out std_logic;                                        -- read
			avm_instruction_readdata      : in  std_logic_vector(31 downto 0) := (others => 'X'); -- readdata
			avm_instruction_waitrequest   : in  std_logic                     := 'X';             -- waitrequest
			avm_instruction_readdatavalid : in  std_logic                     := 'X';             -- readdatavalid
			timer_value                   : in  std_logic_vector(63 downto 0) := (others => 'X'); -- value
			timer_interrupt               : in  std_logic                     := 'X';             -- interrupt
			global_interrupts             : in  std_logic_vector(31 downto 0) := (others => 'X'); -- irq
			DUC_ARADDR                    : out std_logic_vector(31 downto 0);                    -- araddr
			DUC_ARBURST                   : out std_logic_vector(1 downto 0);                     -- arburst
			DUC_ARCACHE                   : out std_logic_vector(3 downto 0);                     -- arcache
			DUC_ARID                      : out std_logic_vector(1 downto 0);                     -- arid
			DUC_ARLEN                     : out std_logic_vector(3 downto 0);                     -- arlen
			DUC_ARLOCK                    : out std_logic_vector(1 downto 0);                     -- arlock
			DUC_ARPROT                    : out std_logic_vector(2 downto 0);                     -- arprot
			DUC_ARREADY                   : in  std_logic                     := 'X';             -- arready
			DUC_ARSIZE                    : out std_logic_vector(2 downto 0);                     -- arsize
			DUC_ARVALID                   : out std_logic;                                        -- arvalid
			DUC_AWADDR                    : out std_logic_vector(31 downto 0);                    -- awaddr
			DUC_AWBURST                   : out std_logic_vector(1 downto 0);                     -- awburst
			DUC_AWCACHE                   : out std_logic_vector(3 downto 0);                     -- awcache
			DUC_AWID                      : out std_logic_vector(1 downto 0);                     -- awid
			DUC_AWLEN                     : out std_logic_vector(3 downto 0);                     -- awlen
			DUC_AWLOCK                    : out std_logic_vector(1 downto 0);                     -- awlock
			DUC_AWPROT                    : out std_logic_vector(2 downto 0);                     -- awprot
			DUC_AWREADY                   : in  std_logic                     := 'X';             -- awready
			DUC_AWSIZE                    : out std_logic_vector(2 downto 0);                     -- awsize
			DUC_AWVALID                   : out std_logic;                                        -- awvalid
			DUC_BID                       : in  std_logic_vector(1 downto 0)  := (others => 'X'); -- bid
			DUC_BREADY                    : out std_logic;                                        -- bready
			DUC_BRESP                     : in  std_logic_vector(1 downto 0)  := (others => 'X'); -- bresp
			DUC_BVALID                    : in  std_logic                     := 'X';             -- bvalid
			DUC_RDATA                     : in  std_logic_vector(31 downto 0) := (others => 'X'); -- rdata
			DUC_RID                       : in  std_logic_vector(1 downto 0)  := (others => 'X'); -- rid
			DUC_RLAST                     : in  std_logic                     := 'X';             -- rlast
			DUC_RREADY                    : out std_logic;                                        -- rready
			DUC_RRESP                     : in  std_logic_vector(1 downto 0)  := (others => 'X'); -- rresp
			DUC_RVALID                    : in  std_logic                     := 'X';             -- rvalid
			DUC_WDATA                     : out std_logic_vector(31 downto 0);                    -- wdata
			DUC_WID                       : out std_logic_vector(1 downto 0);                     -- wid
			DUC_WLAST                     : out std_logic;                                        -- wlast
			DUC_WREADY                    : in  std_logic                     := 'X';             -- wready
			DUC_WSTRB                     : out std_logic_vector(3 downto 0);                     -- wstrb
			DUC_WVALID                    : out std_logic;                                        -- wvalid
			IUC_ARADDR                    : out std_logic_vector(31 downto 0);                    -- araddr
			IUC_ARBURST                   : out std_logic_vector(1 downto 0);                     -- arburst
			IUC_ARCACHE                   : out std_logic_vector(3 downto 0);                     -- arcache
			IUC_ARID                      : out std_logic_vector(1 downto 0);                     -- arid
			IUC_ARLEN                     : out std_logic_vector(3 downto 0);                     -- arlen
			IUC_ARLOCK                    : out std_logic_vector(1 downto 0);                     -- arlock
			IUC_ARPROT                    : out std_logic_vector(2 downto 0);                     -- arprot
			IUC_ARREADY                   : in  std_logic                     := 'X';             -- arready
			IUC_ARSIZE                    : out std_logic_vector(2 downto 0);                     -- arsize
			IUC_ARVALID                   : out std_logic;                                        -- arvalid
			IUC_AWADDR                    : out std_logic_vector(31 downto 0);                    -- awaddr
			IUC_AWBURST                   : out std_logic_vector(1 downto 0);                     -- awburst
			IUC_AWCACHE                   : out std_logic_vector(3 downto 0);                     -- awcache
			IUC_AWID                      : out std_logic_vector(1 downto 0);                     -- awid
			IUC_AWLEN                     : out std_logic_vector(3 downto 0);                     -- awlen
			IUC_AWLOCK                    : out std_logic_vector(1 downto 0);                     -- awlock
			IUC_AWPROT                    : out std_logic_vector(2 downto 0);                     -- awprot
			IUC_AWREADY                   : in  std_logic                     := 'X';             -- awready
			IUC_AWSIZE                    : out std_logic_vector(2 downto 0);                     -- awsize
			IUC_AWVALID                   : out std_logic;                                        -- awvalid
			IUC_BID                       : in  std_logic_vector(1 downto 0)  := (others => 'X'); -- bid
			IUC_BREADY                    : out std_logic;                                        -- bready
			IUC_BRESP                     : in  std_logic_vector(1 downto 0)  := (others => 'X'); -- bresp
			IUC_BVALID                    : in  std_logic                     := 'X';             -- bvalid
			IUC_RDATA                     : in  std_logic_vector(31 downto 0) := (others => 'X'); -- rdata
			IUC_RID                       : in  std_logic_vector(1 downto 0)  := (others => 'X'); -- rid
			IUC_RLAST                     : in  std_logic                     := 'X';             -- rlast
			IUC_RREADY                    : out std_logic;                                        -- rready
			IUC_RRESP                     : in  std_logic_vector(1 downto 0)  := (others => 'X'); -- rresp
			IUC_RVALID                    : in  std_logic                     := 'X';             -- rvalid
			IUC_WDATA                     : out std_logic_vector(31 downto 0);                    -- wdata
			IUC_WID                       : out std_logic_vector(1 downto 0);                     -- wid
			IUC_WLAST                     : out std_logic;                                        -- wlast
			IUC_WREADY                    : in  std_logic                     := 'X';             -- wready
			IUC_WSTRB                     : out std_logic_vector(3 downto 0);                     -- wstrb
			IUC_WVALID                    : out std_logic;                                        -- wvalid
			IC_ARADDR                     : out std_logic_vector(31 downto 0);                    -- araddr
			IC_ARBURST                    : out std_logic_vector(1 downto 0);                     -- arburst
			IC_ARCACHE                    : out std_logic_vector(3 downto 0);                     -- arcache
			IC_ARID                       : out std_logic_vector(1 downto 0);                     -- arid
			IC_ARLEN                      : out std_logic_vector(3 downto 0);                     -- arlen
			IC_ARLOCK                     : out std_logic_vector(1 downto 0);                     -- arlock
			IC_ARPROT                     : out std_logic_vector(2 downto 0);                     -- arprot
			IC_ARREADY                    : in  std_logic                     := 'X';             -- arready
			IC_ARSIZE                     : out std_logic_vector(2 downto 0);                     -- arsize
			IC_ARVALID                    : out std_logic;                                        -- arvalid
			IC_AWADDR                     : out std_logic_vector(31 downto 0);                    -- awaddr
			IC_AWBURST                    : out std_logic_vector(1 downto 0);                     -- awburst
			IC_AWCACHE                    : out std_logic_vector(3 downto 0);                     -- awcache
			IC_AWID                       : out std_logic_vector(1 downto 0);                     -- awid
			IC_AWLEN                      : out std_logic_vector(3 downto 0);                     -- awlen
			IC_AWLOCK                     : out std_logic_vector(1 downto 0);                     -- awlock
			IC_AWPROT                     : out std_logic_vector(2 downto 0);                     -- awprot
			IC_AWREADY                    : in  std_logic                     := 'X';             -- awready
			IC_AWSIZE                     : out std_logic_vector(2 downto 0);                     -- awsize
			IC_AWVALID                    : out std_logic;                                        -- awvalid
			IC_BID                        : in  std_logic_vector(1 downto 0)  := (others => 'X'); -- bid
			IC_BREADY                     : out std_logic;                                        -- bready
			IC_BRESP                      : in  std_logic_vector(1 downto 0)  := (others => 'X'); -- bresp
			IC_BVALID                     : in  std_logic                     := 'X';             -- bvalid
			IC_RDATA                      : in  std_logic_vector(31 downto 0) := (others => 'X'); -- rdata
			IC_RID                        : in  std_logic_vector(1 downto 0)  := (others => 'X'); -- rid
			IC_RLAST                      : in  std_logic                     := 'X';             -- rlast
			IC_RREADY                     : out std_logic;                                        -- rready
			IC_RRESP                      : in  std_logic_vector(1 downto 0)  := (others => 'X'); -- rresp
			IC_RVALID                     : in  std_logic                     := 'X';             -- rvalid
			IC_WDATA                      : out std_logic_vector(31 downto 0);                    -- wdata
			IC_WID                        : out std_logic_vector(1 downto 0);                     -- wid
			IC_WLAST                      : out std_logic;                                        -- wlast
			IC_WREADY                     : in  std_logic                     := 'X';             -- wready
			IC_WSTRB                      : out std_logic_vector(3 downto 0);                     -- wstrb
			IC_WVALID                     : out std_logic;                                        -- wvalid
			DC_ARADDR                     : out std_logic_vector(31 downto 0);                    -- araddr
			DC_ARBURST                    : out std_logic_vector(1 downto 0);                     -- arburst
			DC_ARCACHE                    : out std_logic_vector(3 downto 0);                     -- arcache
			DC_ARID                       : out std_logic_vector(1 downto 0);                     -- arid
			DC_ARLEN                      : out std_logic_vector(3 downto 0);                     -- arlen
			DC_ARLOCK                     : out std_logic_vector(1 downto 0);                     -- arlock
			DC_ARPROT                     : out std_logic_vector(2 downto 0);                     -- arprot
			DC_ARREADY                    : in  std_logic                     := 'X';             -- arready
			DC_ARSIZE                     : out std_logic_vector(2 downto 0);                     -- arsize
			DC_ARVALID                    : out std_logic;                                        -- arvalid
			DC_AWADDR                     : out std_logic_vector(31 downto 0);                    -- awaddr
			DC_AWBURST                    : out std_logic_vector(1 downto 0);                     -- awburst
			DC_AWCACHE                    : out std_logic_vector(3 downto 0);                     -- awcache
			DC_AWID                       : out std_logic_vector(1 downto 0);                     -- awid
			DC_AWLEN                      : out std_logic_vector(3 downto 0);                     -- awlen
			DC_AWLOCK                     : out std_logic_vector(1 downto 0);                     -- awlock
			DC_AWPROT                     : out std_logic_vector(2 downto 0);                     -- awprot
			DC_AWREADY                    : in  std_logic                     := 'X';             -- awready
			DC_AWSIZE                     : out std_logic_vector(2 downto 0);                     -- awsize
			DC_AWVALID                    : out std_logic;                                        -- awvalid
			DC_BID                        : in  std_logic_vector(1 downto 0)  := (others => 'X'); -- bid
			DC_BREADY                     : out std_logic;                                        -- bready
			DC_BRESP                      : in  std_logic_vector(1 downto 0)  := (others => 'X'); -- bresp
			DC_BVALID                     : in  std_logic                     := 'X';             -- bvalid
			DC_RDATA                      : in  std_logic_vector(31 downto 0) := (others => 'X'); -- rdata
			DC_RID                        : in  std_logic_vector(1 downto 0)  := (others => 'X'); -- rid
			DC_RLAST                      : in  std_logic                     := 'X';             -- rlast
			DC_RREADY                     : out std_logic;                                        -- rready
			DC_RRESP                      : in  std_logic_vector(1 downto 0)  := (others => 'X'); -- rresp
			DC_RVALID                     : in  std_logic                     := 'X';             -- rvalid
			DC_WDATA                      : out std_logic_vector(31 downto 0);                    -- wdata
			DC_WID                        : out std_logic_vector(1 downto 0);                     -- wid
			DC_WLAST                      : out std_logic;                                        -- wlast
			DC_WREADY                     : in  std_logic                     := 'X';             -- wready
			DC_WSTRB                      : out std_logic_vector(3 downto 0);                     -- wstrb
			DC_WVALID                     : out std_logic;                                        -- wvalid
			vcp_data0                     : out std_logic_vector(31 downto 0);                    -- data0
			vcp_data1                     : out std_logic_vector(31 downto 0);                    -- data1
			vcp_data2                     : out std_logic_vector(31 downto 0);                    -- data2
			vcp_instruction               : out std_logic_vector(40 downto 0);                    -- instruction
			vcp_valid_instr               : out std_logic;                                        -- valid_instr
			vcp_ready                     : in  std_logic                     := 'X';             -- ready
			vcp_illegal                   : in  std_logic                     := 'X';             -- illegal
			vcp_writeback_data            : in  std_logic_vector(31 downto 0) := (others => 'X'); -- writeback_data
			vcp_writeback_en              : in  std_logic                     := 'X';             -- writeback_en
			vcp_alu_data1                 : in  std_logic_vector(31 downto 0) := (others => 'X'); -- alu_data1
			vcp_alu_data2                 : in  std_logic_vector(31 downto 0) := (others => 'X'); -- alu_data2
			vcp_alu_source_valid          : in  std_logic                     := 'X';             -- alu_source_valid
			vcp_alu_result                : out std_logic_vector(31 downto 0);                    -- alu_result
			vcp_alu_result_valid          : out std_logic;                                        -- alu_result_valid
			data_ADR_O                    : out std_logic_vector(31 downto 0);                    -- ADR_O
			data_DAT_I                    : in  std_logic_vector(31 downto 0) := (others => 'X'); -- DAT_I
			data_DAT_O                    : out std_logic_vector(31 downto 0);                    -- DAT_O
			data_WE_O                     : out std_logic;                                        -- WE_O
			data_SEL_O                    : out std_logic_vector(3 downto 0);                     -- SEL_O
			data_STB_O                    : out std_logic;                                        -- STB_O
			data_ACK_I                    : in  std_logic                     := 'X';             -- ACK_I
			data_CYC_O                    : out std_logic;                                        -- CYC_O
			data_CTI_O                    : out std_logic_vector(2 downto 0);                     -- CTI_O
			data_STALL_I                  : in  std_logic                     := 'X';             -- STALL_I
			instr_ADR_O                   : out std_logic_vector(31 downto 0);                    -- ADR_O
			instr_DAT_I                   : in  std_logic_vector(31 downto 0) := (others => 'X'); -- DAT_I
			instr_STB_O                   : out std_logic;                                        -- STB_O
			instr_ACK_I                   : in  std_logic                     := 'X';             -- ACK_I
			instr_CYC_O                   : out std_logic;                                        -- CYC_O
			instr_CTI_O                   : out std_logic_vector(2 downto 0);                     -- CTI_O
			instr_STALL_I                 : in  std_logic                     := 'X';             -- STALL_I
			ILMB_Addr                     : out std_logic_vector(31 downto 0);                    -- Addr
			ILMB_Byte_Enable              : out std_logic_vector(3 downto 0);                     -- Byte_Enable
			ILMB_Data_Write               : out std_logic_vector(31 downto 0);                    -- Data_Write
			ILMB_AS                       : out std_logic;                                        -- AS
			ILMB_Read_Strobe              : out std_logic;                                        -- Read_Strobe
			ILMB_Write_Strobe             : out std_logic;                                        -- Write_Strobe
			ILMB_Data_Read                : in  std_logic_vector(31 downto 0) := (others => 'X'); -- Data_Read
			ILMB_Ready                    : in  std_logic                     := 'X';             -- Ready
			ILMB_Wait                     : in  std_logic                     := 'X';             -- Wait
			ILMB_CE                       : in  std_logic                     := 'X';             -- CE
			ILMB_UE                       : in  std_logic                     := 'X';             -- UE
			DLMB_Addr                     : out std_logic_vector(31 downto 0);                    -- Addr
			DLMB_Byte_Enable              : out std_logic_vector(3 downto 0);                     -- Byte_Enable
			DLMB_Data_Write               : out std_logic_vector(31 downto 0);                    -- Data_Write
			DLMB_AS                       : out std_logic;                                        -- AS
			DLMB_Read_Strobe              : out std_logic;                                        -- Read_Strobe
			DLMB_Write_Strobe             : out std_logic;                                        -- Write_Strobe
			DLMB_Data_Read                : in  std_logic_vector(31 downto 0) := (others => 'X'); -- Data_Read
			DLMB_Ready                    : in  std_logic                     := 'X';             -- Ready
			DLMB_Wait                     : in  std_logic                     := 'X';             -- Wait
			DLMB_CE                       : in  std_logic                     := 'X';             -- CE
			DLMB_UE                       : in  std_logic                     := 'X'              -- UE
		);
	end component ORCA;

	component qsys_mm_interconnect_0 is
		port (
			orca_timer_0_slave_awaddr                           : out std_logic_vector(3 downto 0);                     -- awaddr
			orca_timer_0_slave_awprot                           : out std_logic_vector(2 downto 0);                     -- awprot
			orca_timer_0_slave_awvalid                          : out std_logic;                                        -- awvalid
			orca_timer_0_slave_awready                          : in  std_logic                     := 'X';             -- awready
			orca_timer_0_slave_wdata                            : out std_logic_vector(31 downto 0);                    -- wdata
			orca_timer_0_slave_wstrb                            : out std_logic_vector(3 downto 0);                     -- wstrb
			orca_timer_0_slave_wvalid                           : out std_logic;                                        -- wvalid
			orca_timer_0_slave_wready                           : in  std_logic                     := 'X';             -- wready
			orca_timer_0_slave_bresp                            : in  std_logic_vector(1 downto 0)  := (others => 'X'); -- bresp
			orca_timer_0_slave_bvalid                           : in  std_logic                     := 'X';             -- bvalid
			orca_timer_0_slave_bready                           : out std_logic;                                        -- bready
			orca_timer_0_slave_araddr                           : out std_logic_vector(3 downto 0);                     -- araddr
			orca_timer_0_slave_arprot                           : out std_logic_vector(2 downto 0);                     -- arprot
			orca_timer_0_slave_arvalid                          : out std_logic;                                        -- arvalid
			orca_timer_0_slave_arready                          : in  std_logic                     := 'X';             -- arready
			orca_timer_0_slave_rdata                            : in  std_logic_vector(31 downto 0) := (others => 'X'); -- rdata
			orca_timer_0_slave_rresp                            : in  std_logic_vector(1 downto 0)  := (others => 'X'); -- rresp
			orca_timer_0_slave_rvalid                           : in  std_logic                     := 'X';             -- rvalid
			orca_timer_0_slave_rready                           : out std_logic;                                        -- rready
			clk_0_clk_clk                                       : in  std_logic                     := 'X';             -- clk
			vectorblox_orca_0_reset_reset_bridge_in_reset_reset : in  std_logic                     := 'X';             -- reset
			vectorblox_orca_0_data_address                      : in  std_logic_vector(31 downto 0) := (others => 'X'); -- address
			vectorblox_orca_0_data_waitrequest                  : out std_logic;                                        -- waitrequest
			vectorblox_orca_0_data_byteenable                   : in  std_logic_vector(3 downto 0)  := (others => 'X'); -- byteenable
			vectorblox_orca_0_data_read                         : in  std_logic                     := 'X';             -- read
			vectorblox_orca_0_data_readdata                     : out std_logic_vector(31 downto 0);                    -- readdata
			vectorblox_orca_0_data_readdatavalid                : out std_logic;                                        -- readdatavalid
			vectorblox_orca_0_data_write                        : in  std_logic                     := 'X';             -- write
			vectorblox_orca_0_data_writedata                    : in  std_logic_vector(31 downto 0) := (others => 'X'); -- writedata
			onchip_memory2_0_s1_address                         : out std_logic_vector(12 downto 0);                    -- address
			onchip_memory2_0_s1_write                           : out std_logic;                                        -- write
			onchip_memory2_0_s1_readdata                        : in  std_logic_vector(31 downto 0) := (others => 'X'); -- readdata
			onchip_memory2_0_s1_writedata                       : out std_logic_vector(31 downto 0);                    -- writedata
			onchip_memory2_0_s1_byteenable                      : out std_logic_vector(3 downto 0);                     -- byteenable
			onchip_memory2_0_s1_chipselect                      : out std_logic;                                        -- chipselect
			onchip_memory2_0_s1_clken                           : out std_logic;                                        -- clken
			pio_0_s1_address                                    : out std_logic_vector(2 downto 0);                     -- address
			pio_0_s1_write                                      : out std_logic;                                        -- write
			pio_0_s1_readdata                                   : in  std_logic_vector(31 downto 0) := (others => 'X'); -- readdata
			pio_0_s1_writedata                                  : out std_logic_vector(31 downto 0);                    -- writedata
			pio_0_s1_chipselect                                 : out std_logic;                                        -- chipselect
			pio_1_s1_address                                    : out std_logic_vector(1 downto 0);                     -- address
			pio_1_s1_write                                      : out std_logic;                                        -- write
			pio_1_s1_readdata                                   : in  std_logic_vector(31 downto 0) := (others => 'X'); -- readdata
			pio_1_s1_writedata                                  : out std_logic_vector(31 downto 0);                    -- writedata
			pio_1_s1_chipselect                                 : out std_logic;                                        -- chipselect
			timer_0_s1_address                                  : out std_logic_vector(2 downto 0);                     -- address
			timer_0_s1_write                                    : out std_logic;                                        -- write
			timer_0_s1_readdata                                 : in  std_logic_vector(15 downto 0) := (others => 'X'); -- readdata
			timer_0_s1_writedata                                : out std_logic_vector(15 downto 0);                    -- writedata
			timer_0_s1_chipselect                               : out std_logic;                                        -- chipselect
			timer_1_s1_address                                  : out std_logic_vector(2 downto 0);                     -- address
			timer_1_s1_write                                    : out std_logic;                                        -- write
			timer_1_s1_readdata                                 : in  std_logic_vector(15 downto 0) := (others => 'X'); -- readdata
			timer_1_s1_writedata                                : out std_logic_vector(15 downto 0);                    -- writedata
			timer_1_s1_chipselect                               : out std_logic;                                        -- chipselect
			uart_0_s1_address                                   : out std_logic_vector(2 downto 0);                     -- address
			uart_0_s1_write                                     : out std_logic;                                        -- write
			uart_0_s1_read                                      : out std_logic;                                        -- read
			uart_0_s1_readdata                                  : in  std_logic_vector(15 downto 0) := (others => 'X'); -- readdata
			uart_0_s1_writedata                                 : out std_logic_vector(15 downto 0);                    -- writedata
			uart_0_s1_begintransfer                             : out std_logic;                                        -- begintransfer
			uart_0_s1_chipselect                                : out std_logic                                         -- chipselect
		);
	end component qsys_mm_interconnect_0;

	component qsys_mm_interconnect_1 is
		port (
			clk_0_clk_clk                                       : in  std_logic                     := 'X';             -- clk
			vectorblox_orca_0_reset_reset_bridge_in_reset_reset : in  std_logic                     := 'X';             -- reset
			vectorblox_orca_0_instruction_address               : in  std_logic_vector(31 downto 0) := (others => 'X'); -- address
			vectorblox_orca_0_instruction_waitrequest           : out std_logic;                                        -- waitrequest
			vectorblox_orca_0_instruction_read                  : in  std_logic                     := 'X';             -- read
			vectorblox_orca_0_instruction_readdata              : out std_logic_vector(31 downto 0);                    -- readdata
			vectorblox_orca_0_instruction_readdatavalid         : out std_logic;                                        -- readdatavalid
			onchip_memory2_0_s2_address                         : out std_logic_vector(12 downto 0);                    -- address
			onchip_memory2_0_s2_write                           : out std_logic;                                        -- write
			onchip_memory2_0_s2_readdata                        : in  std_logic_vector(31 downto 0) := (others => 'X'); -- readdata
			onchip_memory2_0_s2_writedata                       : out std_logic_vector(31 downto 0);                    -- writedata
			onchip_memory2_0_s2_byteenable                      : out std_logic_vector(3 downto 0);                     -- byteenable
			onchip_memory2_0_s2_chipselect                      : out std_logic;                                        -- chipselect
			onchip_memory2_0_s2_clken                           : out std_logic                                         -- clken
		);
	end component qsys_mm_interconnect_1;

	component qsys_irq_mapper is
		port (
			clk           : in  std_logic                     := 'X'; -- clk
			reset         : in  std_logic                     := 'X'; -- reset
			receiver0_irq : in  std_logic                     := 'X'; -- irq
			receiver1_irq : in  std_logic                     := 'X'; -- irq
			receiver2_irq : in  std_logic                     := 'X'; -- irq
			sender_irq    : out std_logic_vector(31 downto 0)         -- irq
		);
	end component qsys_irq_mapper;

	component altera_reset_controller is
		generic (
			NUM_RESET_INPUTS          : integer := 6;
			OUTPUT_RESET_SYNC_EDGES   : string  := "deassert";
			SYNC_DEPTH                : integer := 2;
			RESET_REQUEST_PRESENT     : integer := 0;
			RESET_REQ_WAIT_TIME       : integer := 1;
			MIN_RST_ASSERTION_TIME    : integer := 3;
			RESET_REQ_EARLY_DSRT_TIME : integer := 1;
			USE_RESET_REQUEST_IN0     : integer := 0;
			USE_RESET_REQUEST_IN1     : integer := 0;
			USE_RESET_REQUEST_IN2     : integer := 0;
			USE_RESET_REQUEST_IN3     : integer := 0;
			USE_RESET_REQUEST_IN4     : integer := 0;
			USE_RESET_REQUEST_IN5     : integer := 0;
			USE_RESET_REQUEST_IN6     : integer := 0;
			USE_RESET_REQUEST_IN7     : integer := 0;
			USE_RESET_REQUEST_IN8     : integer := 0;
			USE_RESET_REQUEST_IN9     : integer := 0;
			USE_RESET_REQUEST_IN10    : integer := 0;
			USE_RESET_REQUEST_IN11    : integer := 0;
			USE_RESET_REQUEST_IN12    : integer := 0;
			USE_RESET_REQUEST_IN13    : integer := 0;
			USE_RESET_REQUEST_IN14    : integer := 0;
			USE_RESET_REQUEST_IN15    : integer := 0;
			ADAPT_RESET_REQUEST       : integer := 0
		);
		port (
			reset_in0      : in  std_logic := 'X'; -- reset
			clk            : in  std_logic := 'X'; -- clk
			reset_out      : out std_logic;        -- reset
			reset_req      : out std_logic;        -- reset_req
			reset_req_in0  : in  std_logic := 'X'; -- reset_req
			reset_in1      : in  std_logic := 'X'; -- reset
			reset_req_in1  : in  std_logic := 'X'; -- reset_req
			reset_in2      : in  std_logic := 'X'; -- reset
			reset_req_in2  : in  std_logic := 'X'; -- reset_req
			reset_in3      : in  std_logic := 'X'; -- reset
			reset_req_in3  : in  std_logic := 'X'; -- reset_req
			reset_in4      : in  std_logic := 'X'; -- reset
			reset_req_in4  : in  std_logic := 'X'; -- reset_req
			reset_in5      : in  std_logic := 'X'; -- reset
			reset_req_in5  : in  std_logic := 'X'; -- reset_req
			reset_in6      : in  std_logic := 'X'; -- reset
			reset_req_in6  : in  std_logic := 'X'; -- reset_req
			reset_in7      : in  std_logic := 'X'; -- reset
			reset_req_in7  : in  std_logic := 'X'; -- reset_req
			reset_in8      : in  std_logic := 'X'; -- reset
			reset_req_in8  : in  std_logic := 'X'; -- reset_req
			reset_in9      : in  std_logic := 'X'; -- reset
			reset_req_in9  : in  std_logic := 'X'; -- reset_req
			reset_in10     : in  std_logic := 'X'; -- reset
			reset_req_in10 : in  std_logic := 'X'; -- reset_req
			reset_in11     : in  std_logic := 'X'; -- reset
			reset_req_in11 : in  std_logic := 'X'; -- reset_req
			reset_in12     : in  std_logic := 'X'; -- reset
			reset_req_in12 : in  std_logic := 'X'; -- reset_req
			reset_in13     : in  std_logic := 'X'; -- reset
			reset_req_in13 : in  std_logic := 'X'; -- reset_req
			reset_in14     : in  std_logic := 'X'; -- reset
			reset_req_in14 : in  std_logic := 'X'; -- reset_req
			reset_in15     : in  std_logic := 'X'; -- reset
			reset_req_in15 : in  std_logic := 'X'  -- reset_req
		);
	end component altera_reset_controller;

	signal orca_timer_0_timer_interface_interrupt           : std_logic;                     -- orca_timer_0:timer_interrupt -> vectorblox_orca_0:timer_interrupt
	signal orca_timer_0_timer_interface_value               : std_logic_vector(63 downto 0); -- orca_timer_0:timer_value -> vectorblox_orca_0:timer_value
	signal vectorblox_orca_0_data_readdata                  : std_logic_vector(31 downto 0); -- mm_interconnect_0:vectorblox_orca_0_data_readdata -> vectorblox_orca_0:avm_data_readdata
	signal vectorblox_orca_0_data_waitrequest               : std_logic;                     -- mm_interconnect_0:vectorblox_orca_0_data_waitrequest -> vectorblox_orca_0:avm_data_waitrequest
	signal vectorblox_orca_0_data_address                   : std_logic_vector(31 downto 0); -- vectorblox_orca_0:avm_data_address -> mm_interconnect_0:vectorblox_orca_0_data_address
	signal vectorblox_orca_0_data_byteenable                : std_logic_vector(3 downto 0);  -- vectorblox_orca_0:avm_data_byteenable -> mm_interconnect_0:vectorblox_orca_0_data_byteenable
	signal vectorblox_orca_0_data_read                      : std_logic;                     -- vectorblox_orca_0:avm_data_read -> mm_interconnect_0:vectorblox_orca_0_data_read
	signal vectorblox_orca_0_data_readdatavalid             : std_logic;                     -- mm_interconnect_0:vectorblox_orca_0_data_readdatavalid -> vectorblox_orca_0:avm_data_readdatavalid
	signal vectorblox_orca_0_data_write                     : std_logic;                     -- vectorblox_orca_0:avm_data_write -> mm_interconnect_0:vectorblox_orca_0_data_write
	signal vectorblox_orca_0_data_writedata                 : std_logic_vector(31 downto 0); -- vectorblox_orca_0:avm_data_writedata -> mm_interconnect_0:vectorblox_orca_0_data_writedata
	signal mm_interconnect_0_timer_0_s1_chipselect          : std_logic;                     -- mm_interconnect_0:timer_0_s1_chipselect -> timer_0:chipselect
	signal mm_interconnect_0_timer_0_s1_readdata            : std_logic_vector(15 downto 0); -- timer_0:readdata -> mm_interconnect_0:timer_0_s1_readdata
	signal mm_interconnect_0_timer_0_s1_address             : std_logic_vector(2 downto 0);  -- mm_interconnect_0:timer_0_s1_address -> timer_0:address
	signal mm_interconnect_0_timer_0_s1_write               : std_logic;                     -- mm_interconnect_0:timer_0_s1_write -> mm_interconnect_0_timer_0_s1_write:in
	signal mm_interconnect_0_timer_0_s1_writedata           : std_logic_vector(15 downto 0); -- mm_interconnect_0:timer_0_s1_writedata -> timer_0:writedata
	signal mm_interconnect_0_timer_1_s1_chipselect          : std_logic;                     -- mm_interconnect_0:timer_1_s1_chipselect -> timer_1:chipselect
	signal mm_interconnect_0_timer_1_s1_readdata            : std_logic_vector(15 downto 0); -- timer_1:readdata -> mm_interconnect_0:timer_1_s1_readdata
	signal mm_interconnect_0_timer_1_s1_address             : std_logic_vector(2 downto 0);  -- mm_interconnect_0:timer_1_s1_address -> timer_1:address
	signal mm_interconnect_0_timer_1_s1_write               : std_logic;                     -- mm_interconnect_0:timer_1_s1_write -> mm_interconnect_0_timer_1_s1_write:in
	signal mm_interconnect_0_timer_1_s1_writedata           : std_logic_vector(15 downto 0); -- mm_interconnect_0:timer_1_s1_writedata -> timer_1:writedata
	signal mm_interconnect_0_pio_0_s1_chipselect            : std_logic;                     -- mm_interconnect_0:pio_0_s1_chipselect -> pio_0:chipselect
	signal mm_interconnect_0_pio_0_s1_readdata              : std_logic_vector(31 downto 0); -- pio_0:readdata -> mm_interconnect_0:pio_0_s1_readdata
	signal mm_interconnect_0_pio_0_s1_address               : std_logic_vector(2 downto 0);  -- mm_interconnect_0:pio_0_s1_address -> pio_0:address
	signal mm_interconnect_0_pio_0_s1_write                 : std_logic;                     -- mm_interconnect_0:pio_0_s1_write -> mm_interconnect_0_pio_0_s1_write:in
	signal mm_interconnect_0_pio_0_s1_writedata             : std_logic_vector(31 downto 0); -- mm_interconnect_0:pio_0_s1_writedata -> pio_0:writedata
	signal mm_interconnect_0_onchip_memory2_0_s1_chipselect : std_logic;                     -- mm_interconnect_0:onchip_memory2_0_s1_chipselect -> onchip_memory2_0:chipselect
	signal mm_interconnect_0_onchip_memory2_0_s1_readdata   : std_logic_vector(31 downto 0); -- onchip_memory2_0:readdata -> mm_interconnect_0:onchip_memory2_0_s1_readdata
	signal mm_interconnect_0_onchip_memory2_0_s1_address    : std_logic_vector(12 downto 0); -- mm_interconnect_0:onchip_memory2_0_s1_address -> onchip_memory2_0:address
	signal mm_interconnect_0_onchip_memory2_0_s1_byteenable : std_logic_vector(3 downto 0);  -- mm_interconnect_0:onchip_memory2_0_s1_byteenable -> onchip_memory2_0:byteenable
	signal mm_interconnect_0_onchip_memory2_0_s1_write      : std_logic;                     -- mm_interconnect_0:onchip_memory2_0_s1_write -> onchip_memory2_0:write
	signal mm_interconnect_0_onchip_memory2_0_s1_writedata  : std_logic_vector(31 downto 0); -- mm_interconnect_0:onchip_memory2_0_s1_writedata -> onchip_memory2_0:writedata
	signal mm_interconnect_0_onchip_memory2_0_s1_clken      : std_logic;                     -- mm_interconnect_0:onchip_memory2_0_s1_clken -> onchip_memory2_0:clken
	signal mm_interconnect_0_uart_0_s1_chipselect           : std_logic;                     -- mm_interconnect_0:uart_0_s1_chipselect -> uart_0:chipselect
	signal mm_interconnect_0_uart_0_s1_readdata             : std_logic_vector(15 downto 0); -- uart_0:readdata -> mm_interconnect_0:uart_0_s1_readdata
	signal mm_interconnect_0_uart_0_s1_address              : std_logic_vector(2 downto 0);  -- mm_interconnect_0:uart_0_s1_address -> uart_0:address
	signal mm_interconnect_0_uart_0_s1_read                 : std_logic;                     -- mm_interconnect_0:uart_0_s1_read -> mm_interconnect_0_uart_0_s1_read:in
	signal mm_interconnect_0_uart_0_s1_begintransfer        : std_logic;                     -- mm_interconnect_0:uart_0_s1_begintransfer -> uart_0:begintransfer
	signal mm_interconnect_0_uart_0_s1_write                : std_logic;                     -- mm_interconnect_0:uart_0_s1_write -> mm_interconnect_0_uart_0_s1_write:in
	signal mm_interconnect_0_uart_0_s1_writedata            : std_logic_vector(15 downto 0); -- mm_interconnect_0:uart_0_s1_writedata -> uart_0:writedata
	signal mm_interconnect_0_pio_1_s1_chipselect            : std_logic;                     -- mm_interconnect_0:pio_1_s1_chipselect -> pio_1:chipselect
	signal mm_interconnect_0_pio_1_s1_readdata              : std_logic_vector(31 downto 0); -- pio_1:readdata -> mm_interconnect_0:pio_1_s1_readdata
	signal mm_interconnect_0_pio_1_s1_address               : std_logic_vector(1 downto 0);  -- mm_interconnect_0:pio_1_s1_address -> pio_1:address
	signal mm_interconnect_0_pio_1_s1_write                 : std_logic;                     -- mm_interconnect_0:pio_1_s1_write -> mm_interconnect_0_pio_1_s1_write:in
	signal mm_interconnect_0_pio_1_s1_writedata             : std_logic_vector(31 downto 0); -- mm_interconnect_0:pio_1_s1_writedata -> pio_1:writedata
	signal mm_interconnect_0_orca_timer_0_slave_awaddr      : std_logic_vector(3 downto 0);  -- mm_interconnect_0:orca_timer_0_slave_awaddr -> orca_timer_0:slave_AWADDR
	signal mm_interconnect_0_orca_timer_0_slave_bresp       : std_logic_vector(1 downto 0);  -- orca_timer_0:slave_BRESP -> mm_interconnect_0:orca_timer_0_slave_bresp
	signal mm_interconnect_0_orca_timer_0_slave_arready     : std_logic;                     -- orca_timer_0:slave_ARREADY -> mm_interconnect_0:orca_timer_0_slave_arready
	signal mm_interconnect_0_orca_timer_0_slave_rdata       : std_logic_vector(31 downto 0); -- orca_timer_0:slave_RDATA -> mm_interconnect_0:orca_timer_0_slave_rdata
	signal mm_interconnect_0_orca_timer_0_slave_wstrb       : std_logic_vector(3 downto 0);  -- mm_interconnect_0:orca_timer_0_slave_wstrb -> orca_timer_0:slave_WSTRB
	signal mm_interconnect_0_orca_timer_0_slave_wready      : std_logic;                     -- orca_timer_0:slave_WREADY -> mm_interconnect_0:orca_timer_0_slave_wready
	signal mm_interconnect_0_orca_timer_0_slave_awready     : std_logic;                     -- orca_timer_0:slave_AWREADY -> mm_interconnect_0:orca_timer_0_slave_awready
	signal mm_interconnect_0_orca_timer_0_slave_rready      : std_logic;                     -- mm_interconnect_0:orca_timer_0_slave_rready -> orca_timer_0:slave_RREADY
	signal mm_interconnect_0_orca_timer_0_slave_bready      : std_logic;                     -- mm_interconnect_0:orca_timer_0_slave_bready -> orca_timer_0:slave_BREADY
	signal mm_interconnect_0_orca_timer_0_slave_wvalid      : std_logic;                     -- mm_interconnect_0:orca_timer_0_slave_wvalid -> orca_timer_0:slave_WVALID
	signal mm_interconnect_0_orca_timer_0_slave_araddr      : std_logic_vector(3 downto 0);  -- mm_interconnect_0:orca_timer_0_slave_araddr -> orca_timer_0:slave_ARADDR
	signal mm_interconnect_0_orca_timer_0_slave_arprot      : std_logic_vector(2 downto 0);  -- mm_interconnect_0:orca_timer_0_slave_arprot -> orca_timer_0:slave_ARPROT
	signal mm_interconnect_0_orca_timer_0_slave_rresp       : std_logic_vector(1 downto 0);  -- orca_timer_0:slave_RRESP -> mm_interconnect_0:orca_timer_0_slave_rresp
	signal mm_interconnect_0_orca_timer_0_slave_awprot      : std_logic_vector(2 downto 0);  -- mm_interconnect_0:orca_timer_0_slave_awprot -> orca_timer_0:slave_AWPROT
	signal mm_interconnect_0_orca_timer_0_slave_wdata       : std_logic_vector(31 downto 0); -- mm_interconnect_0:orca_timer_0_slave_wdata -> orca_timer_0:slave_WDATA
	signal mm_interconnect_0_orca_timer_0_slave_arvalid     : std_logic;                     -- mm_interconnect_0:orca_timer_0_slave_arvalid -> orca_timer_0:slave_ARVALID
	signal mm_interconnect_0_orca_timer_0_slave_bvalid      : std_logic;                     -- orca_timer_0:slave_BVALID -> mm_interconnect_0:orca_timer_0_slave_bvalid
	signal mm_interconnect_0_orca_timer_0_slave_awvalid     : std_logic;                     -- mm_interconnect_0:orca_timer_0_slave_awvalid -> orca_timer_0:slave_AWVALID
	signal mm_interconnect_0_orca_timer_0_slave_rvalid      : std_logic;                     -- orca_timer_0:slave_RVALID -> mm_interconnect_0:orca_timer_0_slave_rvalid
	signal vectorblox_orca_0_instruction_readdata           : std_logic_vector(31 downto 0); -- mm_interconnect_1:vectorblox_orca_0_instruction_readdata -> vectorblox_orca_0:avm_instruction_readdata
	signal vectorblox_orca_0_instruction_waitrequest        : std_logic;                     -- mm_interconnect_1:vectorblox_orca_0_instruction_waitrequest -> vectorblox_orca_0:avm_instruction_waitrequest
	signal vectorblox_orca_0_instruction_address            : std_logic_vector(31 downto 0); -- vectorblox_orca_0:avm_instruction_address -> mm_interconnect_1:vectorblox_orca_0_instruction_address
	signal vectorblox_orca_0_instruction_read               : std_logic;                     -- vectorblox_orca_0:avm_instruction_read -> mm_interconnect_1:vectorblox_orca_0_instruction_read
	signal vectorblox_orca_0_instruction_readdatavalid      : std_logic;                     -- mm_interconnect_1:vectorblox_orca_0_instruction_readdatavalid -> vectorblox_orca_0:avm_instruction_readdatavalid
	signal mm_interconnect_1_onchip_memory2_0_s2_chipselect : std_logic;                     -- mm_interconnect_1:onchip_memory2_0_s2_chipselect -> onchip_memory2_0:chipselect2
	signal mm_interconnect_1_onchip_memory2_0_s2_readdata   : std_logic_vector(31 downto 0); -- onchip_memory2_0:readdata2 -> mm_interconnect_1:onchip_memory2_0_s2_readdata
	signal mm_interconnect_1_onchip_memory2_0_s2_address    : std_logic_vector(12 downto 0); -- mm_interconnect_1:onchip_memory2_0_s2_address -> onchip_memory2_0:address2
	signal mm_interconnect_1_onchip_memory2_0_s2_byteenable : std_logic_vector(3 downto 0);  -- mm_interconnect_1:onchip_memory2_0_s2_byteenable -> onchip_memory2_0:byteenable2
	signal mm_interconnect_1_onchip_memory2_0_s2_write      : std_logic;                     -- mm_interconnect_1:onchip_memory2_0_s2_write -> onchip_memory2_0:write2
	signal mm_interconnect_1_onchip_memory2_0_s2_writedata  : std_logic_vector(31 downto 0); -- mm_interconnect_1:onchip_memory2_0_s2_writedata -> onchip_memory2_0:writedata2
	signal mm_interconnect_1_onchip_memory2_0_s2_clken      : std_logic;                     -- mm_interconnect_1:onchip_memory2_0_s2_clken -> onchip_memory2_0:clken2
	signal irq_mapper_receiver0_irq                         : std_logic;                     -- timer_1:irq -> irq_mapper:receiver0_irq
	signal irq_mapper_receiver1_irq                         : std_logic;                     -- timer_0:irq -> irq_mapper:receiver1_irq
	signal irq_mapper_receiver2_irq                         : std_logic;                     -- uart_0:irq -> irq_mapper:receiver2_irq
	signal vectorblox_orca_0_global_interrupts_irq          : std_logic_vector(31 downto 0); -- irq_mapper:sender_irq -> vectorblox_orca_0:global_interrupts
	signal rst_controller_reset_out_reset                   : std_logic;                     -- rst_controller:reset_out -> [irq_mapper:reset, mm_interconnect_0:vectorblox_orca_0_reset_reset_bridge_in_reset_reset, mm_interconnect_1:vectorblox_orca_0_reset_reset_bridge_in_reset_reset, onchip_memory2_0:reset, onchip_memory2_0:reset2, orca_timer_0:reset, rst_controller_reset_out_reset:in, rst_translator:in_reset, vectorblox_orca_0:reset]
	signal rst_controller_reset_out_reset_req               : std_logic;                     -- rst_controller:reset_req -> [onchip_memory2_0:reset_req, onchip_memory2_0:reset_req2, rst_translator:reset_req_in]
	signal reset_reset_n_ports_inv                          : std_logic;                     -- reset_reset_n:inv -> rst_controller:reset_in0
	signal mm_interconnect_0_timer_0_s1_write_ports_inv     : std_logic;                     -- mm_interconnect_0_timer_0_s1_write:inv -> timer_0:write_n
	signal mm_interconnect_0_timer_1_s1_write_ports_inv     : std_logic;                     -- mm_interconnect_0_timer_1_s1_write:inv -> timer_1:write_n
	signal mm_interconnect_0_pio_0_s1_write_ports_inv       : std_logic;                     -- mm_interconnect_0_pio_0_s1_write:inv -> pio_0:write_n
	signal mm_interconnect_0_uart_0_s1_read_ports_inv       : std_logic;                     -- mm_interconnect_0_uart_0_s1_read:inv -> uart_0:read_n
	signal mm_interconnect_0_uart_0_s1_write_ports_inv      : std_logic;                     -- mm_interconnect_0_uart_0_s1_write:inv -> uart_0:write_n
	signal mm_interconnect_0_pio_1_s1_write_ports_inv       : std_logic;                     -- mm_interconnect_0_pio_1_s1_write:inv -> pio_1:write_n
	signal rst_controller_reset_out_reset_ports_inv         : std_logic;                     -- rst_controller_reset_out_reset:inv -> [pio_0:reset_n, pio_1:reset_n, timer_0:reset_n, timer_1:reset_n, uart_0:reset_n]

begin

	onchip_memory2_0 : component qsys_onchip_memory2_0
		port map (
			clk         => clk_clk,                                          --   clk1.clk
			address     => mm_interconnect_0_onchip_memory2_0_s1_address,    --     s1.address
			clken       => mm_interconnect_0_onchip_memory2_0_s1_clken,      --       .clken
			chipselect  => mm_interconnect_0_onchip_memory2_0_s1_chipselect, --       .chipselect
			write       => mm_interconnect_0_onchip_memory2_0_s1_write,      --       .write
			readdata    => mm_interconnect_0_onchip_memory2_0_s1_readdata,   --       .readdata
			writedata   => mm_interconnect_0_onchip_memory2_0_s1_writedata,  --       .writedata
			byteenable  => mm_interconnect_0_onchip_memory2_0_s1_byteenable, --       .byteenable
			reset       => rst_controller_reset_out_reset,                   -- reset1.reset
			reset_req   => rst_controller_reset_out_reset_req,               --       .reset_req
			address2    => mm_interconnect_1_onchip_memory2_0_s2_address,    --     s2.address
			chipselect2 => mm_interconnect_1_onchip_memory2_0_s2_chipselect, --       .chipselect
			clken2      => mm_interconnect_1_onchip_memory2_0_s2_clken,      --       .clken
			write2      => mm_interconnect_1_onchip_memory2_0_s2_write,      --       .write
			readdata2   => mm_interconnect_1_onchip_memory2_0_s2_readdata,   --       .readdata
			writedata2  => mm_interconnect_1_onchip_memory2_0_s2_writedata,  --       .writedata
			byteenable2 => mm_interconnect_1_onchip_memory2_0_s2_byteenable, --       .byteenable
			clk2        => clk_clk,                                          --   clk2.clk
			reset2      => rst_controller_reset_out_reset,                   -- reset2.reset
			reset_req2  => rst_controller_reset_out_reset_req,               --       .reset_req
			freeze      => '0'                                               -- (terminated)
		);

	orca_timer_0 : component orca_timer
		generic map (
			TIMER_WIDTH => 64
		)
		port map (
			clk             => clk_clk,                                      --           clock.clk
			reset           => rst_controller_reset_out_reset,               --           reset.reset
			timer_value     => orca_timer_0_timer_interface_value,           -- Timer_Interface.value
			timer_interrupt => orca_timer_0_timer_interface_interrupt,       --                .interrupt
			slave_ARADDR    => mm_interconnect_0_orca_timer_0_slave_araddr,  --           slave.araddr
			slave_ARPROT    => mm_interconnect_0_orca_timer_0_slave_arprot,  --                .arprot
			slave_ARVALID   => mm_interconnect_0_orca_timer_0_slave_arvalid, --                .arvalid
			slave_ARREADY   => mm_interconnect_0_orca_timer_0_slave_arready, --                .arready
			slave_RDATA     => mm_interconnect_0_orca_timer_0_slave_rdata,   --                .rdata
			slave_RVALID    => mm_interconnect_0_orca_timer_0_slave_rvalid,  --                .rvalid
			slave_RREADY    => mm_interconnect_0_orca_timer_0_slave_rready,  --                .rready
			slave_AWADDR    => mm_interconnect_0_orca_timer_0_slave_awaddr,  --                .awaddr
			slave_AWPROT    => mm_interconnect_0_orca_timer_0_slave_awprot,  --                .awprot
			slave_AWVALID   => mm_interconnect_0_orca_timer_0_slave_awvalid, --                .awvalid
			slave_AWREADY   => mm_interconnect_0_orca_timer_0_slave_awready, --                .awready
			slave_WDATA     => mm_interconnect_0_orca_timer_0_slave_wdata,   --                .wdata
			slave_WSTRB     => mm_interconnect_0_orca_timer_0_slave_wstrb,   --                .wstrb
			slave_WVALID    => mm_interconnect_0_orca_timer_0_slave_wvalid,  --                .wvalid
			slave_WREADY    => mm_interconnect_0_orca_timer_0_slave_wready,  --                .wready
			slave_BVALID    => mm_interconnect_0_orca_timer_0_slave_bvalid,  --                .bvalid
			slave_BREADY    => mm_interconnect_0_orca_timer_0_slave_bready,  --                .bready
			slave_BRESP     => mm_interconnect_0_orca_timer_0_slave_bresp,   --                .bresp
			slave_RRESP     => mm_interconnect_0_orca_timer_0_slave_rresp,   --                .rresp
			slave_AWLOCK    => "00",                                         --     (terminated)
			slave_ARCACHE   => "0000",                                       --     (terminated)
			slave_ARID      => "0000",                                       --     (terminated)
			slave_ARLEN     => "0000",                                       --     (terminated)
			slave_ARLOCK    => "00",                                         --     (terminated)
			slave_ARSIZE    => "000",                                        --     (terminated)
			slave_ARBURST   => "00",                                         --     (terminated)
			slave_AWBURST   => "00",                                         --     (terminated)
			slave_AWCACHE   => "0000",                                       --     (terminated)
			slave_AWID      => "0000",                                       --     (terminated)
			slave_AWLEN     => "0000",                                       --     (terminated)
			slave_AWSIZE    => "000",                                        --     (terminated)
			slave_BID       => open,                                         --     (terminated)
			slave_RID       => open,                                         --     (terminated)
			slave_RLAST     => open,                                         --     (terminated)
			slave_WID       => "0000",                                       --     (terminated)
			slave_WLAST     => '0'                                           --     (terminated)
		);

	pio_0 : component qsys_pio_0
		port map (
			clk        => clk_clk,                                    --                 clk.clk
			reset_n    => rst_controller_reset_out_reset_ports_inv,   --               reset.reset_n
			address    => mm_interconnect_0_pio_0_s1_address,         --                  s1.address
			write_n    => mm_interconnect_0_pio_0_s1_write_ports_inv, --                    .write_n
			writedata  => mm_interconnect_0_pio_0_s1_writedata,       --                    .writedata
			chipselect => mm_interconnect_0_pio_0_s1_chipselect,      --                    .chipselect
			readdata   => mm_interconnect_0_pio_0_s1_readdata,        --                    .readdata
			bidir_port => pio_export                                  -- external_connection.export
		);

	pio_1 : component qsys_pio_1
		port map (
			clk        => clk_clk,                                    --                 clk.clk
			reset_n    => rst_controller_reset_out_reset_ports_inv,   --               reset.reset_n
			address    => mm_interconnect_0_pio_1_s1_address,         --                  s1.address
			write_n    => mm_interconnect_0_pio_1_s1_write_ports_inv, --                    .write_n
			writedata  => mm_interconnect_0_pio_1_s1_writedata,       --                    .writedata
			chipselect => mm_interconnect_0_pio_1_s1_chipselect,      --                    .chipselect
			readdata   => mm_interconnect_0_pio_1_s1_readdata,        --                    .readdata
			out_port   => led_export                                  -- external_connection.export
		);

	timer_0 : component qsys_timer_0
		port map (
			clk        => clk_clk,                                      --   clk.clk
			reset_n    => rst_controller_reset_out_reset_ports_inv,     -- reset.reset_n
			address    => mm_interconnect_0_timer_0_s1_address,         --    s1.address
			writedata  => mm_interconnect_0_timer_0_s1_writedata,       --      .writedata
			readdata   => mm_interconnect_0_timer_0_s1_readdata,        --      .readdata
			chipselect => mm_interconnect_0_timer_0_s1_chipselect,      --      .chipselect
			write_n    => mm_interconnect_0_timer_0_s1_write_ports_inv, --      .write_n
			irq        => irq_mapper_receiver1_irq                      --   irq.irq
		);

	timer_1 : component qsys_timer_1
		port map (
			clk        => clk_clk,                                      --   clk.clk
			reset_n    => rst_controller_reset_out_reset_ports_inv,     -- reset.reset_n
			address    => mm_interconnect_0_timer_1_s1_address,         --    s1.address
			writedata  => mm_interconnect_0_timer_1_s1_writedata,       --      .writedata
			readdata   => mm_interconnect_0_timer_1_s1_readdata,        --      .readdata
			chipselect => mm_interconnect_0_timer_1_s1_chipselect,      --      .chipselect
			write_n    => mm_interconnect_0_timer_1_s1_write_ports_inv, --      .write_n
			irq        => irq_mapper_receiver0_irq                      --   irq.irq
		);

	uart_0 : component qsys_uart_0
		port map (
			clk           => clk_clk,                                     --                 clk.clk
			reset_n       => rst_controller_reset_out_reset_ports_inv,    --               reset.reset_n
			address       => mm_interconnect_0_uart_0_s1_address,         --                  s1.address
			begintransfer => mm_interconnect_0_uart_0_s1_begintransfer,   --                    .begintransfer
			chipselect    => mm_interconnect_0_uart_0_s1_chipselect,      --                    .chipselect
			read_n        => mm_interconnect_0_uart_0_s1_read_ports_inv,  --                    .read_n
			write_n       => mm_interconnect_0_uart_0_s1_write_ports_inv, --                    .write_n
			writedata     => mm_interconnect_0_uart_0_s1_writedata,       --                    .writedata
			readdata      => mm_interconnect_0_uart_0_s1_readdata,        --                    .readdata
			rxd           => uart_rxd,                                    -- external_connection.export
			txd           => uart_txd,                                    --                    .export
			irq           => irq_mapper_receiver2_irq                     --                 irq.irq
		);

	vectorblox_orca_0 : component ORCA
		generic map (
			REGISTER_SIZE                => 32,
			RESET_VECTOR                 => "00000000000000000000001000000000",
			ENABLE_EXCEPTIONS            => 1,
			INTERRUPT_VECTOR             => "00000000000000000000000111000000",
			ENABLE_EXT_INTERRUPTS        => 1,
			NUM_EXT_INTERRUPTS           => 32,
			MAX_IFETCHES_IN_FLIGHT       => 4,
			BTB_ENTRIES                  => 16,
			MULTIPLY_ENABLE              => 1,
			SHIFTER_MAX_CYCLES           => 32,
			DIVIDE_ENABLE                => 1,
			PIPELINE_STAGES              => 4,
			VCP_ENABLE                   => 0,
			POWER_OPTIMIZED              => 0,
			FAMILY                       => "INTEL",
			INSTRUCTION_REQUEST_REGISTER => 1,
			INSTRUCTION_RETURN_REGISTER  => 0,
			DATA_REQUEST_REGISTER        => 1,
			DATA_RETURN_REGISTER         => 0,
			LOG2_BURSTLENGTH             => 4,
			AXI_ID_WIDTH                 => 2,
			AVALON_AUX                   => 1,
			LMB_AUX                      => 0,
			WISHBONE_AUX                 => 0,
			ICACHE_SIZE                  => 0,
			ICACHE_LINE_SIZE             => 32,
			ICACHE_EXTERNAL_WIDTH        => 32,
			IC_REQUEST_REGISTER          => 1,
			IC_RETURN_REGISTER           => 0,
			DCACHE_SIZE                  => 0,
			DCACHE_WRITEBACK             => 1,
			DCACHE_LINE_SIZE             => 32,
			DCACHE_EXTERNAL_WIDTH        => 32,
			DC_REQUEST_REGISTER          => 1,
			DC_RETURN_REGISTER           => 0,
			UC_MEMORY_REGIONS            => 0,
			UMR0_ADDR_BASE               => "00000000000000000000000000000000",
			UMR0_ADDR_LAST               => "11111111111111111111111111111111",
			IUC_REQUEST_REGISTER         => 0,
			IUC_RETURN_REGISTER          => 0,
			DUC_REQUEST_REGISTER         => 0,
			DUC_RETURN_REGISTER          => 0,
			AUX_MEMORY_REGIONS           => 1,
			AMR0_ADDR_BASE               => "00000000000000000000000000000000",
			AMR0_ADDR_LAST               => "11111111111111111111111111111111",
			IAUX_REQUEST_REGISTER        => 2,
			IAUX_RETURN_REGISTER         => 0,
			DAUX_REQUEST_REGISTER        => 2,
			DAUX_RETURN_REGISTER         => 0
		)
		port map (
			clk                           => clk_clk,                                     --             clock.clk
			reset                         => rst_controller_reset_out_reset,              --             reset.reset
			avm_data_address              => vectorblox_orca_0_data_address,              --              data.address
			avm_data_byteenable           => vectorblox_orca_0_data_byteenable,           --                  .byteenable
			avm_data_read                 => vectorblox_orca_0_data_read,                 --                  .read
			avm_data_readdata             => vectorblox_orca_0_data_readdata,             --                  .readdata
			avm_data_write                => vectorblox_orca_0_data_write,                --                  .write
			avm_data_writedata            => vectorblox_orca_0_data_writedata,            --                  .writedata
			avm_data_waitrequest          => vectorblox_orca_0_data_waitrequest,          --                  .waitrequest
			avm_data_readdatavalid        => vectorblox_orca_0_data_readdatavalid,        --                  .readdatavalid
			avm_instruction_address       => vectorblox_orca_0_instruction_address,       --       instruction.address
			avm_instruction_read          => vectorblox_orca_0_instruction_read,          --                  .read
			avm_instruction_readdata      => vectorblox_orca_0_instruction_readdata,      --                  .readdata
			avm_instruction_waitrequest   => vectorblox_orca_0_instruction_waitrequest,   --                  .waitrequest
			avm_instruction_readdatavalid => vectorblox_orca_0_instruction_readdatavalid, --                  .readdatavalid
			timer_value                   => orca_timer_0_timer_interface_value,          --   Timer_Interface.value
			timer_interrupt               => orca_timer_0_timer_interface_interrupt,      --                  .interrupt
			global_interrupts             => vectorblox_orca_0_global_interrupts_irq,     -- global_interrupts.irq
			DUC_ARADDR                    => open,                                        --       (terminated)
			DUC_ARBURST                   => open,                                        --       (terminated)
			DUC_ARCACHE                   => open,                                        --       (terminated)
			DUC_ARID                      => open,                                        --       (terminated)
			DUC_ARLEN                     => open,                                        --       (terminated)
			DUC_ARLOCK                    => open,                                        --       (terminated)
			DUC_ARPROT                    => open,                                        --       (terminated)
			DUC_ARREADY                   => '0',                                         --       (terminated)
			DUC_ARSIZE                    => open,                                        --       (terminated)
			DUC_ARVALID                   => open,                                        --       (terminated)
			DUC_AWADDR                    => open,                                        --       (terminated)
			DUC_AWBURST                   => open,                                        --       (terminated)
			DUC_AWCACHE                   => open,                                        --       (terminated)
			DUC_AWID                      => open,                                        --       (terminated)
			DUC_AWLEN                     => open,                                        --       (terminated)
			DUC_AWLOCK                    => open,                                        --       (terminated)
			DUC_AWPROT                    => open,                                        --       (terminated)
			DUC_AWREADY                   => '0',                                         --       (terminated)
			DUC_AWSIZE                    => open,                                        --       (terminated)
			DUC_AWVALID                   => open,                                        --       (terminated)
			DUC_BID                       => "00",                                        --       (terminated)
			DUC_BREADY                    => open,                                        --       (terminated)
			DUC_BRESP                     => "00",                                        --       (terminated)
			DUC_BVALID                    => '0',                                         --       (terminated)
			DUC_RDATA                     => "00000000000000000000000000000000",          --       (terminated)
			DUC_RID                       => "00",                                        --       (terminated)
			DUC_RLAST                     => '0',                                         --       (terminated)
			DUC_RREADY                    => open,                                        --       (terminated)
			DUC_RRESP                     => "00",                                        --       (terminated)
			DUC_RVALID                    => '0',                                         --       (terminated)
			DUC_WDATA                     => open,                                        --       (terminated)
			DUC_WID                       => open,                                        --       (terminated)
			DUC_WLAST                     => open,                                        --       (terminated)
			DUC_WREADY                    => '0',                                         --       (terminated)
			DUC_WSTRB                     => open,                                        --       (terminated)
			DUC_WVALID                    => open,                                        --       (terminated)
			IUC_ARADDR                    => open,                                        --       (terminated)
			IUC_ARBURST                   => open,                                        --       (terminated)
			IUC_ARCACHE                   => open,                                        --       (terminated)
			IUC_ARID                      => open,                                        --       (terminated)
			IUC_ARLEN                     => open,                                        --       (terminated)
			IUC_ARLOCK                    => open,                                        --       (terminated)
			IUC_ARPROT                    => open,                                        --       (terminated)
			IUC_ARREADY                   => '0',                                         --       (terminated)
			IUC_ARSIZE                    => open,                                        --       (terminated)
			IUC_ARVALID                   => open,                                        --       (terminated)
			IUC_AWADDR                    => open,                                        --       (terminated)
			IUC_AWBURST                   => open,                                        --       (terminated)
			IUC_AWCACHE                   => open,                                        --       (terminated)
			IUC_AWID                      => open,                                        --       (terminated)
			IUC_AWLEN                     => open,                                        --       (terminated)
			IUC_AWLOCK                    => open,                                        --       (terminated)
			IUC_AWPROT                    => open,                                        --       (terminated)
			IUC_AWREADY                   => '0',                                         --       (terminated)
			IUC_AWSIZE                    => open,                                        --       (terminated)
			IUC_AWVALID                   => open,                                        --       (terminated)
			IUC_BID                       => "00",                                        --       (terminated)
			IUC_BREADY                    => open,                                        --       (terminated)
			IUC_BRESP                     => "00",                                        --       (terminated)
			IUC_BVALID                    => '0',                                         --       (terminated)
			IUC_RDATA                     => "00000000000000000000000000000000",          --       (terminated)
			IUC_RID                       => "00",                                        --       (terminated)
			IUC_RLAST                     => '0',                                         --       (terminated)
			IUC_RREADY                    => open,                                        --       (terminated)
			IUC_RRESP                     => "00",                                        --       (terminated)
			IUC_RVALID                    => '0',                                         --       (terminated)
			IUC_WDATA                     => open,                                        --       (terminated)
			IUC_WID                       => open,                                        --       (terminated)
			IUC_WLAST                     => open,                                        --       (terminated)
			IUC_WREADY                    => '0',                                         --       (terminated)
			IUC_WSTRB                     => open,                                        --       (terminated)
			IUC_WVALID                    => open,                                        --       (terminated)
			IC_ARADDR                     => open,                                        --       (terminated)
			IC_ARBURST                    => open,                                        --       (terminated)
			IC_ARCACHE                    => open,                                        --       (terminated)
			IC_ARID                       => open,                                        --       (terminated)
			IC_ARLEN                      => open,                                        --       (terminated)
			IC_ARLOCK                     => open,                                        --       (terminated)
			IC_ARPROT                     => open,                                        --       (terminated)
			IC_ARREADY                    => '0',                                         --       (terminated)
			IC_ARSIZE                     => open,                                        --       (terminated)
			IC_ARVALID                    => open,                                        --       (terminated)
			IC_AWADDR                     => open,                                        --       (terminated)
			IC_AWBURST                    => open,                                        --       (terminated)
			IC_AWCACHE                    => open,                                        --       (terminated)
			IC_AWID                       => open,                                        --       (terminated)
			IC_AWLEN                      => open,                                        --       (terminated)
			IC_AWLOCK                     => open,                                        --       (terminated)
			IC_AWPROT                     => open,                                        --       (terminated)
			IC_AWREADY                    => '0',                                         --       (terminated)
			IC_AWSIZE                     => open,                                        --       (terminated)
			IC_AWVALID                    => open,                                        --       (terminated)
			IC_BID                        => "00",                                        --       (terminated)
			IC_BREADY                     => open,                                        --       (terminated)
			IC_BRESP                      => "00",                                        --       (terminated)
			IC_BVALID                     => '0',                                         --       (terminated)
			IC_RDATA                      => "00000000000000000000000000000000",          --       (terminated)
			IC_RID                        => "00",                                        --       (terminated)
			IC_RLAST                      => '0',                                         --       (terminated)
			IC_RREADY                     => open,                                        --       (terminated)
			IC_RRESP                      => "00",                                        --       (terminated)
			IC_RVALID                     => '0',                                         --       (terminated)
			IC_WDATA                      => open,                                        --       (terminated)
			IC_WID                        => open,                                        --       (terminated)
			IC_WLAST                      => open,                                        --       (terminated)
			IC_WREADY                     => '0',                                         --       (terminated)
			IC_WSTRB                      => open,                                        --       (terminated)
			IC_WVALID                     => open,                                        --       (terminated)
			DC_ARADDR                     => open,                                        --       (terminated)
			DC_ARBURST                    => open,                                        --       (terminated)
			DC_ARCACHE                    => open,                                        --       (terminated)
			DC_ARID                       => open,                                        --       (terminated)
			DC_ARLEN                      => open,                                        --       (terminated)
			DC_ARLOCK                     => open,                                        --       (terminated)
			DC_ARPROT                     => open,                                        --       (terminated)
			DC_ARREADY                    => '0',                                         --       (terminated)
			DC_ARSIZE                     => open,                                        --       (terminated)
			DC_ARVALID                    => open,                                        --       (terminated)
			DC_AWADDR                     => open,                                        --       (terminated)
			DC_AWBURST                    => open,                                        --       (terminated)
			DC_AWCACHE                    => open,                                        --       (terminated)
			DC_AWID                       => open,                                        --       (terminated)
			DC_AWLEN                      => open,                                        --       (terminated)
			DC_AWLOCK                     => open,                                        --       (terminated)
			DC_AWPROT                     => open,                                        --       (terminated)
			DC_AWREADY                    => '0',                                         --       (terminated)
			DC_AWSIZE                     => open,                                        --       (terminated)
			DC_AWVALID                    => open,                                        --       (terminated)
			DC_BID                        => "00",                                        --       (terminated)
			DC_BREADY                     => open,                                        --       (terminated)
			DC_BRESP                      => "00",                                        --       (terminated)
			DC_BVALID                     => '0',                                         --       (terminated)
			DC_RDATA                      => "00000000000000000000000000000000",          --       (terminated)
			DC_RID                        => "00",                                        --       (terminated)
			DC_RLAST                      => '0',                                         --       (terminated)
			DC_RREADY                     => open,                                        --       (terminated)
			DC_RRESP                      => "00",                                        --       (terminated)
			DC_RVALID                     => '0',                                         --       (terminated)
			DC_WDATA                      => open,                                        --       (terminated)
			DC_WID                        => open,                                        --       (terminated)
			DC_WLAST                      => open,                                        --       (terminated)
			DC_WREADY                     => '0',                                         --       (terminated)
			DC_WSTRB                      => open,                                        --       (terminated)
			DC_WVALID                     => open,                                        --       (terminated)
			vcp_data0                     => open,                                        --       (terminated)
			vcp_data1                     => open,                                        --       (terminated)
			vcp_data2                     => open,                                        --       (terminated)
			vcp_instruction               => open,                                        --       (terminated)
			vcp_valid_instr               => open,                                        --       (terminated)
			vcp_ready                     => '0',                                         --       (terminated)
			vcp_illegal                   => '0',                                         --       (terminated)
			vcp_writeback_data            => "00000000000000000000000000000000",          --       (terminated)
			vcp_writeback_en              => '0',                                         --       (terminated)
			vcp_alu_data1                 => "00000000000000000000000000000000",          --       (terminated)
			vcp_alu_data2                 => "00000000000000000000000000000000",          --       (terminated)
			vcp_alu_source_valid          => '0',                                         --       (terminated)
			vcp_alu_result                => open,                                        --       (terminated)
			vcp_alu_result_valid          => open,                                        --       (terminated)
			data_ADR_O                    => open,                                        --       (terminated)
			data_DAT_I                    => "00000000000000000000000000000000",          --       (terminated)
			data_DAT_O                    => open,                                        --       (terminated)
			data_WE_O                     => open,                                        --       (terminated)
			data_SEL_O                    => open,                                        --       (terminated)
			data_STB_O                    => open,                                        --       (terminated)
			data_ACK_I                    => '0',                                         --       (terminated)
			data_CYC_O                    => open,                                        --       (terminated)
			data_CTI_O                    => open,                                        --       (terminated)
			data_STALL_I                  => '0',                                         --       (terminated)
			instr_ADR_O                   => open,                                        --       (terminated)
			instr_DAT_I                   => "00000000000000000000000000000000",          --       (terminated)
			instr_STB_O                   => open,                                        --       (terminated)
			instr_ACK_I                   => '0',                                         --       (terminated)
			instr_CYC_O                   => open,                                        --       (terminated)
			instr_CTI_O                   => open,                                        --       (terminated)
			instr_STALL_I                 => '0',                                         --       (terminated)
			ILMB_Addr                     => open,                                        --       (terminated)
			ILMB_Byte_Enable              => open,                                        --       (terminated)
			ILMB_Data_Write               => open,                                        --       (terminated)
			ILMB_AS                       => open,                                        --       (terminated)
			ILMB_Read_Strobe              => open,                                        --       (terminated)
			ILMB_Write_Strobe             => open,                                        --       (terminated)
			ILMB_Data_Read                => "00000000000000000000000000000000",          --       (terminated)
			ILMB_Ready                    => '0',                                         --       (terminated)
			ILMB_Wait                     => '0',                                         --       (terminated)
			ILMB_CE                       => '0',                                         --       (terminated)
			ILMB_UE                       => '0',                                         --       (terminated)
			DLMB_Addr                     => open,                                        --       (terminated)
			DLMB_Byte_Enable              => open,                                        --       (terminated)
			DLMB_Data_Write               => open,                                        --       (terminated)
			DLMB_AS                       => open,                                        --       (terminated)
			DLMB_Read_Strobe              => open,                                        --       (terminated)
			DLMB_Write_Strobe             => open,                                        --       (terminated)
			DLMB_Data_Read                => "00000000000000000000000000000000",          --       (terminated)
			DLMB_Ready                    => '0',                                         --       (terminated)
			DLMB_Wait                     => '0',                                         --       (terminated)
			DLMB_CE                       => '0',                                         --       (terminated)
			DLMB_UE                       => '0'                                          --       (terminated)
		);

	mm_interconnect_0 : component qsys_mm_interconnect_0
		port map (
			orca_timer_0_slave_awaddr                           => mm_interconnect_0_orca_timer_0_slave_awaddr,      --                            orca_timer_0_slave.awaddr
			orca_timer_0_slave_awprot                           => mm_interconnect_0_orca_timer_0_slave_awprot,      --                                              .awprot
			orca_timer_0_slave_awvalid                          => mm_interconnect_0_orca_timer_0_slave_awvalid,     --                                              .awvalid
			orca_timer_0_slave_awready                          => mm_interconnect_0_orca_timer_0_slave_awready,     --                                              .awready
			orca_timer_0_slave_wdata                            => mm_interconnect_0_orca_timer_0_slave_wdata,       --                                              .wdata
			orca_timer_0_slave_wstrb                            => mm_interconnect_0_orca_timer_0_slave_wstrb,       --                                              .wstrb
			orca_timer_0_slave_wvalid                           => mm_interconnect_0_orca_timer_0_slave_wvalid,      --                                              .wvalid
			orca_timer_0_slave_wready                           => mm_interconnect_0_orca_timer_0_slave_wready,      --                                              .wready
			orca_timer_0_slave_bresp                            => mm_interconnect_0_orca_timer_0_slave_bresp,       --                                              .bresp
			orca_timer_0_slave_bvalid                           => mm_interconnect_0_orca_timer_0_slave_bvalid,      --                                              .bvalid
			orca_timer_0_slave_bready                           => mm_interconnect_0_orca_timer_0_slave_bready,      --                                              .bready
			orca_timer_0_slave_araddr                           => mm_interconnect_0_orca_timer_0_slave_araddr,      --                                              .araddr
			orca_timer_0_slave_arprot                           => mm_interconnect_0_orca_timer_0_slave_arprot,      --                                              .arprot
			orca_timer_0_slave_arvalid                          => mm_interconnect_0_orca_timer_0_slave_arvalid,     --                                              .arvalid
			orca_timer_0_slave_arready                          => mm_interconnect_0_orca_timer_0_slave_arready,     --                                              .arready
			orca_timer_0_slave_rdata                            => mm_interconnect_0_orca_timer_0_slave_rdata,       --                                              .rdata
			orca_timer_0_slave_rresp                            => mm_interconnect_0_orca_timer_0_slave_rresp,       --                                              .rresp
			orca_timer_0_slave_rvalid                           => mm_interconnect_0_orca_timer_0_slave_rvalid,      --                                              .rvalid
			orca_timer_0_slave_rready                           => mm_interconnect_0_orca_timer_0_slave_rready,      --                                              .rready
			clk_0_clk_clk                                       => clk_clk,                                          --                                     clk_0_clk.clk
			vectorblox_orca_0_reset_reset_bridge_in_reset_reset => rst_controller_reset_out_reset,                   -- vectorblox_orca_0_reset_reset_bridge_in_reset.reset
			vectorblox_orca_0_data_address                      => vectorblox_orca_0_data_address,                   --                        vectorblox_orca_0_data.address
			vectorblox_orca_0_data_waitrequest                  => vectorblox_orca_0_data_waitrequest,               --                                              .waitrequest
			vectorblox_orca_0_data_byteenable                   => vectorblox_orca_0_data_byteenable,                --                                              .byteenable
			vectorblox_orca_0_data_read                         => vectorblox_orca_0_data_read,                      --                                              .read
			vectorblox_orca_0_data_readdata                     => vectorblox_orca_0_data_readdata,                  --                                              .readdata
			vectorblox_orca_0_data_readdatavalid                => vectorblox_orca_0_data_readdatavalid,             --                                              .readdatavalid
			vectorblox_orca_0_data_write                        => vectorblox_orca_0_data_write,                     --                                              .write
			vectorblox_orca_0_data_writedata                    => vectorblox_orca_0_data_writedata,                 --                                              .writedata
			onchip_memory2_0_s1_address                         => mm_interconnect_0_onchip_memory2_0_s1_address,    --                           onchip_memory2_0_s1.address
			onchip_memory2_0_s1_write                           => mm_interconnect_0_onchip_memory2_0_s1_write,      --                                              .write
			onchip_memory2_0_s1_readdata                        => mm_interconnect_0_onchip_memory2_0_s1_readdata,   --                                              .readdata
			onchip_memory2_0_s1_writedata                       => mm_interconnect_0_onchip_memory2_0_s1_writedata,  --                                              .writedata
			onchip_memory2_0_s1_byteenable                      => mm_interconnect_0_onchip_memory2_0_s1_byteenable, --                                              .byteenable
			onchip_memory2_0_s1_chipselect                      => mm_interconnect_0_onchip_memory2_0_s1_chipselect, --                                              .chipselect
			onchip_memory2_0_s1_clken                           => mm_interconnect_0_onchip_memory2_0_s1_clken,      --                                              .clken
			pio_0_s1_address                                    => mm_interconnect_0_pio_0_s1_address,               --                                      pio_0_s1.address
			pio_0_s1_write                                      => mm_interconnect_0_pio_0_s1_write,                 --                                              .write
			pio_0_s1_readdata                                   => mm_interconnect_0_pio_0_s1_readdata,              --                                              .readdata
			pio_0_s1_writedata                                  => mm_interconnect_0_pio_0_s1_writedata,             --                                              .writedata
			pio_0_s1_chipselect                                 => mm_interconnect_0_pio_0_s1_chipselect,            --                                              .chipselect
			pio_1_s1_address                                    => mm_interconnect_0_pio_1_s1_address,               --                                      pio_1_s1.address
			pio_1_s1_write                                      => mm_interconnect_0_pio_1_s1_write,                 --                                              .write
			pio_1_s1_readdata                                   => mm_interconnect_0_pio_1_s1_readdata,              --                                              .readdata
			pio_1_s1_writedata                                  => mm_interconnect_0_pio_1_s1_writedata,             --                                              .writedata
			pio_1_s1_chipselect                                 => mm_interconnect_0_pio_1_s1_chipselect,            --                                              .chipselect
			timer_0_s1_address                                  => mm_interconnect_0_timer_0_s1_address,             --                                    timer_0_s1.address
			timer_0_s1_write                                    => mm_interconnect_0_timer_0_s1_write,               --                                              .write
			timer_0_s1_readdata                                 => mm_interconnect_0_timer_0_s1_readdata,            --                                              .readdata
			timer_0_s1_writedata                                => mm_interconnect_0_timer_0_s1_writedata,           --                                              .writedata
			timer_0_s1_chipselect                               => mm_interconnect_0_timer_0_s1_chipselect,          --                                              .chipselect
			timer_1_s1_address                                  => mm_interconnect_0_timer_1_s1_address,             --                                    timer_1_s1.address
			timer_1_s1_write                                    => mm_interconnect_0_timer_1_s1_write,               --                                              .write
			timer_1_s1_readdata                                 => mm_interconnect_0_timer_1_s1_readdata,            --                                              .readdata
			timer_1_s1_writedata                                => mm_interconnect_0_timer_1_s1_writedata,           --                                              .writedata
			timer_1_s1_chipselect                               => mm_interconnect_0_timer_1_s1_chipselect,          --                                              .chipselect
			uart_0_s1_address                                   => mm_interconnect_0_uart_0_s1_address,              --                                     uart_0_s1.address
			uart_0_s1_write                                     => mm_interconnect_0_uart_0_s1_write,                --                                              .write
			uart_0_s1_read                                      => mm_interconnect_0_uart_0_s1_read,                 --                                              .read
			uart_0_s1_readdata                                  => mm_interconnect_0_uart_0_s1_readdata,             --                                              .readdata
			uart_0_s1_writedata                                 => mm_interconnect_0_uart_0_s1_writedata,            --                                              .writedata
			uart_0_s1_begintransfer                             => mm_interconnect_0_uart_0_s1_begintransfer,        --                                              .begintransfer
			uart_0_s1_chipselect                                => mm_interconnect_0_uart_0_s1_chipselect            --                                              .chipselect
		);

	mm_interconnect_1 : component qsys_mm_interconnect_1
		port map (
			clk_0_clk_clk                                       => clk_clk,                                          --                                     clk_0_clk.clk
			vectorblox_orca_0_reset_reset_bridge_in_reset_reset => rst_controller_reset_out_reset,                   -- vectorblox_orca_0_reset_reset_bridge_in_reset.reset
			vectorblox_orca_0_instruction_address               => vectorblox_orca_0_instruction_address,            --                 vectorblox_orca_0_instruction.address
			vectorblox_orca_0_instruction_waitrequest           => vectorblox_orca_0_instruction_waitrequest,        --                                              .waitrequest
			vectorblox_orca_0_instruction_read                  => vectorblox_orca_0_instruction_read,               --                                              .read
			vectorblox_orca_0_instruction_readdata              => vectorblox_orca_0_instruction_readdata,           --                                              .readdata
			vectorblox_orca_0_instruction_readdatavalid         => vectorblox_orca_0_instruction_readdatavalid,      --                                              .readdatavalid
			onchip_memory2_0_s2_address                         => mm_interconnect_1_onchip_memory2_0_s2_address,    --                           onchip_memory2_0_s2.address
			onchip_memory2_0_s2_write                           => mm_interconnect_1_onchip_memory2_0_s2_write,      --                                              .write
			onchip_memory2_0_s2_readdata                        => mm_interconnect_1_onchip_memory2_0_s2_readdata,   --                                              .readdata
			onchip_memory2_0_s2_writedata                       => mm_interconnect_1_onchip_memory2_0_s2_writedata,  --                                              .writedata
			onchip_memory2_0_s2_byteenable                      => mm_interconnect_1_onchip_memory2_0_s2_byteenable, --                                              .byteenable
			onchip_memory2_0_s2_chipselect                      => mm_interconnect_1_onchip_memory2_0_s2_chipselect, --                                              .chipselect
			onchip_memory2_0_s2_clken                           => mm_interconnect_1_onchip_memory2_0_s2_clken       --                                              .clken
		);

	irq_mapper : component qsys_irq_mapper
		port map (
			clk           => clk_clk,                                 --       clk.clk
			reset         => rst_controller_reset_out_reset,          -- clk_reset.reset
			receiver0_irq => irq_mapper_receiver0_irq,                -- receiver0.irq
			receiver1_irq => irq_mapper_receiver1_irq,                -- receiver1.irq
			receiver2_irq => irq_mapper_receiver2_irq,                -- receiver2.irq
			sender_irq    => vectorblox_orca_0_global_interrupts_irq  --    sender.irq
		);

	rst_controller : component altera_reset_controller
		generic map (
			NUM_RESET_INPUTS          => 1,
			OUTPUT_RESET_SYNC_EDGES   => "deassert",
			SYNC_DEPTH                => 2,
			RESET_REQUEST_PRESENT     => 1,
			RESET_REQ_WAIT_TIME       => 1,
			MIN_RST_ASSERTION_TIME    => 3,
			RESET_REQ_EARLY_DSRT_TIME => 1,
			USE_RESET_REQUEST_IN0     => 0,
			USE_RESET_REQUEST_IN1     => 0,
			USE_RESET_REQUEST_IN2     => 0,
			USE_RESET_REQUEST_IN3     => 0,
			USE_RESET_REQUEST_IN4     => 0,
			USE_RESET_REQUEST_IN5     => 0,
			USE_RESET_REQUEST_IN6     => 0,
			USE_RESET_REQUEST_IN7     => 0,
			USE_RESET_REQUEST_IN8     => 0,
			USE_RESET_REQUEST_IN9     => 0,
			USE_RESET_REQUEST_IN10    => 0,
			USE_RESET_REQUEST_IN11    => 0,
			USE_RESET_REQUEST_IN12    => 0,
			USE_RESET_REQUEST_IN13    => 0,
			USE_RESET_REQUEST_IN14    => 0,
			USE_RESET_REQUEST_IN15    => 0,
			ADAPT_RESET_REQUEST       => 0
		)
		port map (
			reset_in0      => reset_reset_n_ports_inv,            -- reset_in0.reset
			clk            => clk_clk,                            --       clk.clk
			reset_out      => rst_controller_reset_out_reset,     -- reset_out.reset
			reset_req      => rst_controller_reset_out_reset_req, --          .reset_req
			reset_req_in0  => '0',                                -- (terminated)
			reset_in1      => '0',                                -- (terminated)
			reset_req_in1  => '0',                                -- (terminated)
			reset_in2      => '0',                                -- (terminated)
			reset_req_in2  => '0',                                -- (terminated)
			reset_in3      => '0',                                -- (terminated)
			reset_req_in3  => '0',                                -- (terminated)
			reset_in4      => '0',                                -- (terminated)
			reset_req_in4  => '0',                                -- (terminated)
			reset_in5      => '0',                                -- (terminated)
			reset_req_in5  => '0',                                -- (terminated)
			reset_in6      => '0',                                -- (terminated)
			reset_req_in6  => '0',                                -- (terminated)
			reset_in7      => '0',                                -- (terminated)
			reset_req_in7  => '0',                                -- (terminated)
			reset_in8      => '0',                                -- (terminated)
			reset_req_in8  => '0',                                -- (terminated)
			reset_in9      => '0',                                -- (terminated)
			reset_req_in9  => '0',                                -- (terminated)
			reset_in10     => '0',                                -- (terminated)
			reset_req_in10 => '0',                                -- (terminated)
			reset_in11     => '0',                                -- (terminated)
			reset_req_in11 => '0',                                -- (terminated)
			reset_in12     => '0',                                -- (terminated)
			reset_req_in12 => '0',                                -- (terminated)
			reset_in13     => '0',                                -- (terminated)
			reset_req_in13 => '0',                                -- (terminated)
			reset_in14     => '0',                                -- (terminated)
			reset_req_in14 => '0',                                -- (terminated)
			reset_in15     => '0',                                -- (terminated)
			reset_req_in15 => '0'                                 -- (terminated)
		);

	reset_reset_n_ports_inv <= not reset_reset_n;

	mm_interconnect_0_timer_0_s1_write_ports_inv <= not mm_interconnect_0_timer_0_s1_write;

	mm_interconnect_0_timer_1_s1_write_ports_inv <= not mm_interconnect_0_timer_1_s1_write;

	mm_interconnect_0_pio_0_s1_write_ports_inv <= not mm_interconnect_0_pio_0_s1_write;

	mm_interconnect_0_uart_0_s1_read_ports_inv <= not mm_interconnect_0_uart_0_s1_read;

	mm_interconnect_0_uart_0_s1_write_ports_inv <= not mm_interconnect_0_uart_0_s1_write;

	mm_interconnect_0_pio_1_s1_write_ports_inv <= not mm_interconnect_0_pio_1_s1_write;

	rst_controller_reset_out_reset_ports_inv <= not rst_controller_reset_out_reset;

end architecture rtl; -- of qsys
