# Contains functions of hal.h (and port.c) that are required to be written in assembler

.globl PrintStack
.globl PrintStack2

# Prints current stack (addr value) from sp to sp+length to uart
# a0 = length
PrintStack:
	beqz a0, 3f
	addi sp, sp, -32
	sw s0, 4(sp)
	sw s1, 8(sp)
	sw s2, 12(sp)
	sw ra, 16(sp)
	mv s1, a0
	li s0, 0
	1:
		mv a0, sp
		add a0, a0, s0
		add a0, a0, s0
		add a0, a0, s0
		add a0, a0, s0
		addi a0, a0, 32
		mv s2, a0
		li a1, 0
		jal DebugWriteHex32
		
		li a0, 0x09
		jal DebugPut
	
		lw a0, 0(s2)
		li a1, 1
		jal UARTWriteHex32
		
		addi s0, s0, 1
		bne s0, s1, 1b
	lw ra, 16(sp)
	lw s2, 12(sp)
	lw s1, 8(sp)
	lw s0, 4(sp)
	addi sp, sp, 32
3:
	ret
	

# Prints address (addr value) from a1 to a1+length to uart
# a0 = length
# a1 = address
PrintStack2:
	beqz a0, 3f
	addi sp, sp, -32
	sw s0, 4(sp)
	sw s1, 8(sp)
	sw s2, 12(sp)
	sw ra, 16(sp)
	sw a1, 20(sp)
	mv s1, a0
	li s0, 0
	1:
		lw a0, 20(sp)
		add a0, a0, s0
		add a0, a0, s0
		add a0, a0, s0
		add a0, a0, s0
		mv s2, a0
		li a1, 0
		jal DebugWriteHex32
		
		li a0, 0x09
		jal DebugPut
	
		lw a0, 0(s2)
		li a1, 1
		jal DebugWriteHex32
		
		addi s0, s0, 1
		bne s0, s1, 1b
	lw ra, 16(sp)
	lw s2, 12(sp)
	lw s1, 8(sp)
	lw s0, 4(sp)
	addi sp, sp, 32
3:
	ret
