#ifndef TIMER_H
#define TIMER_H

#include <stdint.h>

typedef volatile struct {
	uint32_t status;
	uint32_t control;
	uint32_t periodl;
	uint32_t periodh;
	uint32_t snapl;
	uint32_t snaph;
} Timer;

void TimerSetPeriod(Timer* pTimer, uint32_t period);
void TimerEnableInterrupt(Timer* pTimer);
void TimerDisableInterrupt(Timer* pTimer);
void TimerStart(Timer* pTimer);
void TimerStop(Timer* pTimer);
void TimerRearm(Timer* pTimer);

#endif // TIMER_H