#include "riscvdef.h"
#include "FPGAConfig.h"
#include "debug.h"

// Function type without parameters and return value
typedef void (*void_func)(void);

void halEnableInterrupts(void);
void halDisableInterrupts(void);
void halRaiseSoftInterrupt(void);
void halClearSoftInterupt(void);
void halSetInterruptHandler(void_func f, uint32_t index);
void_func halGetInterruptHandler(uint32_t index);
void halEnableIRQ(uint32_t bitmask);
void disableEnableIRQ(uint32_t bitmask);

uintptr_t handle_trap(uintptr_t mcause, uintptr_t mepc);
uintptr_t handle_interrupt(uintptr_t mcause, uintptr_t mepc, uintptr_t stackPointer);

void SysTick_Handler(uintptr_t stackPointer);

// Assume alignment 4 bytes and growth direction negative (lower stack values newer)
void PrintStack(uint32_t length);
void PrintStack2(uint32_t length, uintptr_t stackAddress);
