OUTPUT_FORMAT("elf32-littleriscv", "elf32-littleriscv", "elf32-littleriscv")
OUTPUT_ARCH( "riscv" )

MEMORY
{
 OCRAM (rwx) : ORIGIN = 0x00000000, LENGTH = 32K
}

ENTRY(_start)

_end_of_memory = ORIGIN(OCRAM) + LENGTH(OCRAM) - 1;
_sp = ALIGN(_end_of_memory - 0x10, 4);

SECTIONS
{
  . = 0x00000100;

  .init . :
  {
	  *(.init)
  } > OCRAM

  .text :
  {
    obj/crt.S.o *(.text)
  } > OCRAM

  .data : { *(.data) } > OCRAM
  .rodata : { *(.rodata) } > OCRAM

  .sdata : {
    _gp = . + 0x800;
    *(.srodata.cst16) *(.srodata.cst8) *(.srodata.cst4) *(.srodata.cst2) *(.srodata*)
    *(.sdata .sdata.* .gnu.linkonce.s.*)
  } > OCRAM

  .sbss : {
    *(.sbss .sbss.* .gnu.linkonce.sb.*)
    *(.scommon)
  } > OCRAM

  .bss : { *(.bss) } > OCRAM

  .tdata :
  {
    _tls_data = .;
    *(.tdata)
  } > OCRAM

  .tbss :
  {
    *(.tbss)
  } > OCRAM

  _end = .;
}
