#include "timer.h"

void TimerSetPeriod(Timer* pTimer, uint32_t period){
	pTimer->periodl = period & 0xFFFF;
	pTimer->periodh = (period >> 16) & 0xFFFF;
	pTimer->control = 0;
}

void TimerEnableInterrupt(Timer* pTimer){
	pTimer->control |= 1;
	pTimer->status = 0;
}

void TimerDisableInterrupt(Timer* pTimer){
	pTimer->control &= ~1;
	pTimer->status = 0;
}

void TimerStart(Timer* pTimer){
	pTimer->control |= 4;
}

void TimerStop(Timer* pTimer){
	pTimer->control |= 8;
}

void TimerRearm(Timer* pTimer){
	TimerEnableInterrupt(pTimer);
	TimerStart(pTimer);
}
